*----------------------------------------------------------------
c     subroutine esamin(khl,mkang,iphiv,iphic,mmm,numbx,
c    * wt1,wtexa,errm,errmw,nrefas,shi)
c     USE PhaseModule

c     dimension khl(3,mmm),iphiv(mmm),iphic(mmm),
c    *          wt1(mmm),wtexa(mmm),mkang(mmm)
c     dimension shi(4)
c
c     nuset = 0
c     ifmin = 1
c     numby = numbx - 1
c     call examin(nuset,mkang,khl,iphiv,iphic,mmm,numby,wtexa,ifmin)
c     nrefas = isumal
c     shi(:) = shiftexam(:)
c     errm = erore
c     errmw = erorepes
c
c     return
c     end
c -----------------------------------------------------------------
      subroutine statres

      USE General
      USE Riflessi
      USE PhaseModule
      USE Param

      common/conue/shi(4),ishi,shi1(4)

      character*80 tirang
      dimension shi2(4)

      real, allocatable   ::dres(:),gg(:),
     +                      diff1(:),diff2(:),diff3(:),
     +                      wtt_1(:),wtt_2(:),wtt_3(:),wtt_4(:)


      write(6,*)'        *****************************************'
      write(6,*)'        *         STATISTICs DATA ANALYSIS      *'
      write(6,*)'        *****************************************'

      allocate(dres(nrefl),gg(nrefl),
     *       diff1(nrefl),diff2(nrefl),
     *       diff3(nrefl),wtt_1(nrefl),
     *       wtt_2(nrefl),wtt_3(nrefl), 
     *       wtt_4(nrefl), stat=ierr)
      if (ierr /=0) then
         write(lo,*)'Allocate error in statres'
         return
      endif

      shi2(1)=0.0
      shi2(2)=0.0
      shi2(3)=0.0
      shi2(4)=1.0

       call esamin(khl,mkang,ipub,iphaz,nrefl,1,wtt1,wt,
     *             errm1,errmw1,nref1,shi2)

      nnos=0
      nfas=0
      nfasT=0
      nrcs=0
      nrncs=0
      sumerr=0.0
      sumerrT=0.0
      do 10 i=1,nrefl
        kk=i
        diff1(kk)=e1(kk)-e2(kk)
        if (knw.eq.1.and.wt(kk).gt.0.0) then
          err=abs(iphaz(kk)-ipub(kk))
          err=abs(amod(err+3600.,360.))
          if (err.gt.180.)err=360.-err
          sumerrT=sumerrT+err
          nfasT=nfasT+1
          if (mkang(kk).ne.1) then
             nrcs=nrcs+1
             if (err.eq.0) nfas=nfas+1
          else
             nrncs=nrncs+1
             sumerr=sumerr+err
          endif
        endif
         gg(kk)=2.0*e1(kk)*e2(kk)
         if (inobs(kk).eq.1) nnos=nnos+1
         dres(kk)=0.5/sqrt(rhov(kk))
         wtt_1(kk)=0.0
         wtt_2(kk)=0.0
         wtt_3(kk)=0.0
         wtt_4(kk)=0.0
         if (wtd(kk).gt.0.0) then
            wtt_1(kk)=wt(kk)
            if (evet(kk) < 0.7.and.wtd(kk) > 0.7) then
               wtt_3(kk)=wt(kk)
               wtt_4(kk)=wtd(kk)
            endif
         else
            wtt_2(kk)=wt(kk)
         endif
 10   continue

*-----  Riflessi c.s a n.c.s
      if (nrcs.gt.0) write(lo,*)'Riflessi c.s',nrcs,nfas/float(nrcs)
      if (nrncs.gt.0) write(lo,*)'Riflessi n.c.s',nrncs,
     *               sumerr/float(nrncs)
      if (nfasT.gt.0) write(lo,*)'Riflessi Totali',nfasT,
     *               sumerrT/float(nfasT)

c     tirang='|Eo|'
c     call ParamDistribution(tirang,knw,evet,khl,nrefl,1,ipub,iphaz,
c    *  shi2,wt,segni1,20,0.0)
c     
c     call ParamDistribution(tirang,knw,evet,khl,nrefl,1,ipub,iphaz,
c    *  shi2,wtt_1,segni1,20,0.0)

c     call ParamDistribution(tirang,knw,evet,khl,nrefl,1,ipub,iphaz,
c    *  shi2,wtt_2,segni1,20,0.0)

c     tirang='|Eo|< 0.7'
c     call ParamDistribution(tirang,knw,evet,khl,nrefl,1,ipub,iphad,
c    *  shi2,wtt_4,segni1,20,0.0)

c     call ParamDistribution(tirang,knw,evet,khl,nrefl,1,ipub,iphaz,
c    *  shi2,wtt_3,segni1,20,0.0)



      tirang='|Fo|'
      call ParamDistribution(tirang,knw,fovet,khl,nrefl,1,ipub,iphaz,
     *  shi2,wt,segni1,20,0.0)

      if (nrefExt > 0) then
      tirang='|Fo|'
      call ParamDistribution(tirang,knw,fovet,khl,nrefl-nrefExt,1,
     *  ipub,iphaz,
     *  shi2,wt,segni1,20,0.0)

      tirang='|Ft|'
      call ParamDistribution(tirang,knw,fmod,khl,nrefl-nrefExt,1,
     *  ipub,iphaz,
     *  shi2,wt,segni1,20,0.0)

      tirang='|Fo|'
      call ParamDistribution(tirang,knw,fovet,khl,nrefl,nrefl-nrefExt+1,
     *  ipub,iphaz,
     *  shi2,wt,segni1,20,0.0)

      tirang='|Ft|'
      call ParamDistribution(tirang,knw,fmod,khl,nrefl,nrefl-nrefExt+1,
     *  ipub,iphaz,
     *  shi2,wt,segni1,20,0.0)
      endif
      
      tirang='|Fo|'
      call ParamDistribution(tirang,knw,fovet,khl,nrefl,1,ipub,iphaz,
     *  shi2,wtt_1,segni1,20,0.0)

      call ParamDistribution(tirang,knw,fovet,khl,nrefl,1,ipub,iphaz,
     *  shi2,wtt_2,segni1,20,0.0)

c     tirang='|Fc|'
c     call ParamDistribution(tirang,knw,fcvet,khl,nrefl,1,ipub,iphaz,
c    *  shi2,wt,segni1,20,0.0)
c     
c     call ParamDistribution(tirang,knw,fcvet,khl,nrefl,1,ipub,iphaz,
c    *  shi2,wtt_1,segni1,20,0.0)

c     call ParamDistribution(tirang,knw,fcvet,khl,nrefl,1,ipub,iphaz,
c    *  shi2,wtt_2,segni1,20,0.0)

*----- in funzione di Epar
c     tirang='|Epi|'
c     call ParamDistribution(tirang,knw,e1,khl,nrefl,1,ipub,iphaz,
c    *  shi2,wtt_1,segni1,20,2.0)

c     call ParamDistribution(tirang,knw,e1,khl,nrefl,1,ipub,iphaz,
c    *  shi2,wtt_2,segni1,20,2.0)

c     tirang='|Eppi|'
c     call ParamDistribution(tirang,knw,e2,khl,nrefl,1,ipub,iphaz,
c    *  shi2,wtt_1,segni1,20,2.0)

c     call ParamDistribution(tirang,knw,e2,khl,nrefl,1,ipub,iphaz,
c    *  shi2,wtt_2,segni1,20,2.0)

*----- in funzione di Pesi
      tirang='Weights'
      call ParamDistribution(tirang,2,wt,khl,nrefl,1,ipub,iphaz,
     *  shi2,wt,segni1,20,1.0)

      if (nrefExt > 0) then
      call ParamDistribution(tirang,2,wt,khl,nrefl-nrefExt,1,
     *  ipub,iphaz,
     *  shi2,wt,segni1,20,1.0)

      call ParamDistribution(tirang,2,wt,khl,nrefl,nrefl-nrefExt+1,
     *  ipub,iphaz,
     *  shi2,wt,segni1,20,1.0)
      endif

c     call ParamDistribution(tirang,2,wt,khl,nrefl,1,ipub,iphaz,
c    *  shi2,wt,segni1,-20,1.0)

      call ParamDistribution(tirang,2,wt,khl,nrefl,1,ipub,iphaz,
     *  shi2,wtt_1,segni1,20,1.0)

      call ParamDistribution(tirang,2,wt,khl,nrefl,1,ipub,iphaz,
     *  shi2,wtt_2,segni1,20,1.0)

*----- in funzione della res. (A)
      tirang='Res (A)'
      call ParamDistribution(tirang,knw,dres,khl,nrefl,1,ipub,iphaz,
     *  shi2,wt,segni1,20,0.0)

      call ParamDistribution(tirang,knw,dres,khl,nrefl,1,ipub,iphaz,
     *  shi2,wtt_1,segni1,20,0.0)

      call ParamDistribution(tirang,knw,dres,khl,nrefl,1,ipub,iphaz,
     *  shi2,wtt_2,segni1,20,0.0)

      deallocate(dres,gg,
     *       diff1,diff2,diff3,
     *       wtt_1,wtt_2,wtt_3,wtt_4, stat=ierr)
      return
      end
*----------------------------------------
      subroutine SceltaRef(isort,Ntot,gg,wt,Nend,Ninit,perc,numb)

      dimension gg(Ntot),wt(Ntot)

      real, allocatable :: Psort(:)

      allocate(Psort(Ntot),stat=ierr)

      ic=0
      do 10 i=Ninit, Nend
       if (wt(i).gt.0.0.and.gg(i).ne.0.0) then
           ic=ic+1
           Psort(ic)=gg(i)
       endif 

 10   continue

      nref1=ic
      call sortall(isort,Psort,nref1)

      if (perc.gt.0.0) then
         ncond1=nint(nref1*perc)
      elseif (numb.gt.0) then
         ncond1=numb
      else
         ncond1=nref1
      endif


      ncond1=max0(1,ncond1)
      ncond1=min0(Nend-Ninit,ncond1)

      sog=Psort(ncond1)

c     numb=0
      do 20 i=Ninit,Nend
        if (isort.lt.0) then
          if (gg(i).lt.sog.and.gg(i).ne.0.0) then
            wt(i)=0.0
          else
c           numb=numb+1
          endif
      else
          if (gg(i).gt.sog) then
            wt(i)=0.0
          else
c           numb=numb+1
          endif
      endif
 20   continue

c     perc=real(numb)/real(nrefl)

      deallocate(Psort,stat=ierr)

      return
      end
*----------------------------------------
      subroutine ElimRef(Ntot,iorde,gg,ifa,wt,Nend,Ninit,perc,numb)

      dimension gg(Ntot),wt(Ntot),ifa(Ntot),iorde(Ntot)

      real, allocatable :: Psort(:)

      allocate(Psort(Ntot),stat=ierr)


      ic=0
      do 10 i=Ninit, Nend
       ii=iorde(i)
       if (wt(ii).gt.0.0) then
           ic=ic+1
           Psort(ic)=gg(ii)
       endif 

 10   continue

      nref1=ic

      call sortall(-1,Psort,nref1)


      if (perc.gt.0.0) then
         ncond1=nint(nref1*perc)
      elseif (numb.gt.0) then
         ncond1=numb
      else
         ncond1=nref1
      endif


      ncond1=max0(1,ncond1)
      ncond1=min0(Nend-Ninit,ncond1)

      sog=Psort(ncond1)


      numb1=0
      do 20 i=Ninit,Nend
        ii=iorde(i)
        if (gg(ii).gt.sog.and.wt(i).gt.0.0) then
c         wt(ii)=0.0
          ifa(i)=ifa(i)+180.
          ifa(i)=amod(ifa(i)+3600.,360.)
          numb1=numb1+1
        endif
 20   continue

      write(6,*)'Change Ref',sog,numb1,ncond1
      deallocate(Psort,stat=ierr)

      return
      end

c-----------------------------------------------------------------
      subroutine cumdeg(delta,numbD,range1,disde1)
      USE General
      real delta(numbD),range(52),disde(52),range1(52),disde1(52)
      integer hisde(52),cumde(52)
      dimension vet(32),ivet(32)
      equivalence(vet(1),ivet(1))

      nrang=11
      do 5 i=1,nrang
       cumde(i)=0
       hisde(i)=0
       disde1(i)=0.0
       disde(i)=0.0
    5 continue
      npos=0
      nneg=0
      rpm=0.0
      sumde=0.0
      rmin=99999.0
      rmax=-99999.0
      call sortall(1,delta,numbD)
      numbD1=numbD
      do 10 i=1,numbD
         if (abs(delta(i)).gt.9000) then
             numbD1=i-1
             goto 12
         endif
   10 continue
   12 rmin=delta(1)
      rmax=delta(numbD1)
      dev=rmax-rmin
      iaa=nint(dev)
      if (iaa.gt.0) then
                     dev=float(iaa)/10.
                    else
                     dev=float(nint(10.*dev))/100. 
                    end if
      range(1)=float(int(10.*rmin))/10.
      range(nrang)=float(nint(10.*rmax))/10.
      do 15 i=2,nrang-1
      range(i)=range(i-1)+dev
   15 continue
      range(1)=rmin
      range(nrang)=rmax
      m=2
      nn=0
      do 20 i=1,numbD1
         sumde=sumde+abs(delta(i))
         if (delta(i).gt.0) npos=npos+1
         if (delta(i).lt.0) nneg=nneg+1
         if (delta(i).le.range(m)) then
                                    nn=nn+1
                                    hisde(m)=nn
                                   else
                                    nn=1
                                    m=m+1
                                    if (m.gt.nrang) m=nrang
                                    hisde(m)=nn
                                   endif
 20   continue
      cumde(nrang)=hisde(nrang)
      do 30 i=1,nrang-1
       cumde(nrang-i)=cumde(nrang+1-i)+hisde(nrang-i)
 30   continue
      range1(1)=rmin
      range1(nrang+1)=rmax
      disde1(1)=0.0
      disde1(nrang+1)=0.0
      do 40 i=2,nrang
       range1(i)=(range(i-1)+range(i))/2.0
       disde1(i)=real(hisde(i))/numbD1
 40   continue
       disde(1)=(disde1(1)+disde1(2))/2.0
      do 50 i=2,nrang-2
       disde(i)=(disde1(i-1)+disde1(i)+disde1(i+1))/3.0
 50   continue
       disde(nrang-1)=(disde1(nrang-2)+disde1(nrang))/2.0
      if (nneg.gt.0.and.npos.gt.0) rpm=float(npos)/float(nneg)
      demed=sumde/float(numbD1)
c
      write(lo,1000)numbD1
      write (lo,'(1x,7h Delta ,11(1x,f5.2))')(range(i),i=1,nrang)
      write (lo,'(5x,2hno,8x,i5,10(1x,i5))')(hisde(i),i=2,nrang)
c
      if (rpm.gt.0) then
                     write(lo,'(/,3x,6hRPN = ,f6.2)')rpm
                    else
                     write(lo,'(/,3x,7hNpos = ,i6,/)')npos
                     write(lo,'(/,3x,7hNneg = ,i6,/)')nneg
                    endif
      write(lo,'(/,3x,18h< |Delta_SIR| > = ,f6.2)')demed
c
1000    format(//,1x,'distribution of |delta| ',
     *  'for',i6,' reflections  - number of ',
     *  '|delta| .le. limit',/) 
      return
      end
c---------------------------------------------------------------------
      subroutine regres(x,y,n,a,b)
      dimension x(50),y(50)
      real koef

      sumx=0.0
      sumxy=0.0
      sumx2=0.0
      sumy=0.0
      sumy2=0.0
      sum1=0.0
      sum2=0.0
      sumk1=0.0
      sumk2=0.0
      sumk3=0.0
      do 10 i=1,n
      sumx=sumx+x(i)
      sumx2=sumx2+x(i)**2
      sumy=sumy+y(i)
      sumy2=sumy2+y(i)**2
      sumxy=sumxy+x(i)*y(i)
 10   continue
      xmed=sumx/n
      ymed=sumy/n
      x2med=sumx2/n
      y2med=sumy2/n
      xymed=sumxy/n

      do 30 i=1,n
      sum1=x(i)-xmed
      sum2=y(i)-ymed
      sumk1=sumk1+sum1*sum2
      sumk2=sumk2+sum1**2
      sumk3=sumk3+sum2**2
 30   continue
      koef=sumk1/sqrt(sumk2*sumk3)
      delta=n*sumx2-(sumx)**2
      aa=n*sumxy-sumx*sumy
      bb=sumx2*sumy-sumx*sumxy
      a=aa/delta
      b=bb/delta
      write(6,*)a,b,koef
      return
      end
c--------------------------------------------------------------
      subroutine pherrdis(tirang,dij,khl,nrif,ic,ia,ib,shi,c,
     *                    segni,nrang1,rmax11)


      USE General
      integer PGOPEN
      character*80,strFile,strHead(3)
      character*200,strLog

      dimension ia(nrif),ib(nrif),khl(3,nrif),c(nrif),
     *          segni(nrif)

      dimension cumde(201),range(201),disa1(201),disb1(201),cmed(201),
     * disa2(201),disb2(201),dij(nrif),shi(4),his(201),
     * csegni(201),cumerr1(200),cumerr2(201),
     * cumerp1(201),cumerp2(201),cumse(201),ccmed(201)
      character tirang(2)*11
      integer his,cumde
      real xplot(201),yplot(201)
**      real, allocatable :: dijs(:),iorde1(:)
      real, allocatable :: dijs(:)
      integer, allocatable::iorde1(:)

c--
      
      if (nrif.le.0) return

      ALLOCATE (dijs(nrif),iorde1(nrif), stat = ierr)

      nrang=10
      rmax1=rmax11
      if (nrang1 > 0) then
         nrang=nrang1
      elseif (nrang1 < 0) then
         nrang=nrif/abs(nrang1)
         nRifbin=abs(nrang1)
      endif

      itot=0
      sumsegni=0.0
      sumdif1=0.0
      sumdisb1=0.0
      sumdif2=0.0
      sumdisb2=0.0
      sumc=0.0

      range(:)=0.0
      his(:)=0
      cumde(:)=0
      cumse(:)=0.0
      csegni(:)=0.0
      cmed(:)=0.0
      disa1(:)=0.0
      disb1(:)=0.0
      cumerr1(:)=0.0
      cumerp1(:)=0.0
      disa2(:)=0.0
      cumerr2(:)=0.0
      cumerp2(:)=0.0
      disb2(:)=0.0
      ccmed(:)=0.0

      rmin=99999.
      rabs=99999.
      rmax=-99999.
      ii=0
      do 5 i=1,nrif
       if (i.lt.ic) goto 5
c      if (i.eq.0.or.i.gt.nrif) write(6,*)i
       if (c(i).le.0.0.or.dij(i).eq.0.0) goto 5
       ii=ii+1
       dijs(ii)=dij(i)
       iorde1(ii)=i
       if (abs(dij(i)).lt.rabs) rabs=abs(dij(i))
       if (dij(i).lt.rmin) rmin=dij(i)
       if (dij(i).gt.rmax) rmax=dij(i)
    5 continue
      numsort=ii
      if (rmax.eq.rmin) return 
      if (numsort.eq.0) return 
      call sortall3(1,dijs,1,numsort,iorde1)


c     if (nrang1 >=0) then
        nsogrmax=nint(0.99*numsort)
        rmax1=dijs(nsogrmax)
        if (rmin.lt.0.0) then
          rmax=amax1(rmax,abs(rmin))
          rmin=-1.0*rmax
        endif
        rmaxg=rmax
        rming=rmin
        if (rmax1.gt.0.0) then
          rmax=rmax1
          if (rmin.lt.0.0)rmin=-1.0*rmax
        endif

c--
        dev=rmax-rmin
        iaa=nint(dev)
        rang=float(nrang)
        if (iaa.gt.0) then
          dev=float(iaa)/rang
        else
          dev=dev/rang
        end if
        if (rmin.ge.0.0) then
         range(1)=float(int(10.*rmin))/10.
         do 12 i=2,nrang
            range(i)=range(i-1)+dev
  12     continue
        else
         range(1)=float(nint(10.*rmin))/10.
         nrangi=nint(rang/2.0)
         nrang=2*nrangi
         dev=rmax-rabs
         dev=dev/float(nrangi)
         do 13 i=2,nrangi-1
            range(i)=range(i-1)+dev
  13     continue
         range(nrangi)=-rabs
         range(nrangi+1)=rabs
         do 14 i=nrangi+2,nrang
            range(i)=range(i-1)+dev
  14     continue
        endif
c       range(1)=rmin
        range(1)=rming
        nrang=nrang+1
        range(nrang)=rmax
        range(nrang+1)=rmaxg
c     endif
c--
      if (nrang1 < 0) then
        n=2
      else
        n=2
      endif

      ii=0

      do 15 i=1,numsort
        ii=ii+1
        k=iorde1(i)
        jh=khl(1,k)
        jk=khl(2,k)
        jl=khl(3,k)
        shift=jh*shi(1)+jk*shi(2)+jl*shi(3)
        shift=360.* shift + ia(k)
        dif1=shift - ib(k)
        dif2=shift + ib(k)
        dif1=abs(amod(dif1,360.))
        if (dif1.gt.180.)dif1=360.-dif1
        dif2=abs(amod(dif2,360.))
        if (dif2.gt.180.)dif2=360.-dif2

        if (nrang1 < 0) then
          if (ii==nRifbin) then
           range(n)=dijs(i)
           n=n+1
           ii=0
          else
           his(n)=his(n)+1
           disa1(n)=disa1(n)+dif1
           disa2(n)=disa2(n)+dif2
           disb1(n)=disb1(n)+dif1*c(k)
           disb2(n)=disb2(n)+dif2*c(k)
           cmed(n)=cmed(n)+c(k)
           csegni(n)=csegni(n)+segni(k)
          endif
        else
   17     if (dijs(i).le.range(n)) then
            his(n)=his(n)+1
          else
            n=n+1
            if (n.gt.nrang) n=nrang+1
            goto 17
          endif
          disa1(n)=disa1(n)+dif1
          disa2(n)=disa2(n)+dif2
          disb1(n)=disb1(n)+dif1*c(k)
          disb2(n)=disb2(n)+dif2*c(k)
          cmed(n)=cmed(n)+c(k)
          csegni(n)=csegni(n)+segni(k)
        endif
   15 continue
*-----cumulative


      cumerp1(nrang+1)=disb1(nrang+1)
      cumerp2(nrang+1)=disb2(nrang+1)
      ccmed(nrang+1)=cmed(nrang+1)
      do i=1,nrang
      cumerp1(nrang+1-i)=cumerp1(nrang+2-i)+disb1(nrang+1-i)
      cumerp2(nrang+1-i)=cumerp2(nrang+2-i)+disb2(nrang+1-i)
      ccmed(nrang+1-i)=ccmed(nrang+2-i)+cmed(nrang+1-i)
      enddo
*-----
      do 20 i=1,nrang+1
         if (his(i).gt.0) then
            itot=itot+his(i)
            sumdif1=sumdif1+disa1(i)
            sumdif2=sumdif2+disa2(i)
            sumdisb1=sumdisb1+disb1(i)
            sumdisb2=sumdisb2+disb2(i)
            sumc=sumc+cmed(i)
            sumsegni=sumsegni+csegni(i)
            disa1(i)=disa1(i)/float(his(i))
            disa2(i)=disa2(i)/float(his(i))
            disb1(i)=disb1(i)/cmed(i)
            disb2(i)=disb2(i)/cmed(i)
            csegni(i)=csegni(i)/float(his(i))
            csegni(i)=100.*csegni(i)
         else
            disa1(i)=0.0
            disa2(i)=0.0
            disb1(i)=0.0
            disb2(i)=0.0
            csegni(i)=0.0
            cmed(i)=0.0
         endif
   20 continue
      if (itot.le.0) return
      tot=float(itot)
      segnim=100.*sumsegni/tot
      dif1m=sumdif1/tot
      dif2m=sumdif2/tot
      disb1m=sumdisb1/sumc
      disb2m=sumdisb2/sumc
c-----cumulative 
      cumde(nrang+1)  =his(nrang+1)
      cumse(nrang+1)  =float(his(nrang+1))*csegni(nrang+1)
      cumerr1(nrang+1)=float(his(nrang+1))*disa1(nrang+1)
      cumerr2(nrang+1)=float(his(nrang+1))*disa2(nrang+1)
      do 25 i=1,nrang
      cumde(nrang+1-i)  =cumde(nrang+2-i)+his(nrang+1-i)
      cumse(nrang+1-i)  =cumse(nrang+2-i)+csegni(nrang+1-i)*
     *                   float(his(nrang+1-i))
      cumerr1(nrang+1-i)=cumerr1(nrang+2-i)+disa1(nrang+1-i)*
     *                   float(his(nrang+1-i))
      cumerr2(nrang+1-i)=cumerr2(nrang+2-i)+disa2(nrang+1-i)*
     *                   float(his(nrang+1-i))
   25 continue

      if (knw.eq.1) write(lo,200)tirang(1)
      if (knw.eq.0) write(lo,250)tirang(1)
      do 30 i=2,nrang+1
      if (his(i).eq.0) go to 30
      if (knw.gt.0 )then
      write(lo,100) range(i-1),range(i),his(i),csegni(i),
     *              disa1(i),disb1(i),disa2(i),disb2(i),
     *              cumde(i),cumse(i)/float(cumde(i)),
     * cumerr1(i)/float(cumde(i)),cumerp1(i)/ccmed(i),
     * cumerr2(i)/float(cumde(i)),cumerp2(i)/ccmed(i)
      else
      write(lo,150) range(i-1),range(i),his(i),cumde(i)
      endif
   30 continue
      write(lo,'(24x,42(1h.))')
      if (knw.gt.0) then
      write(lo,300)itot,segnim,dif1m,disb1m,dif2m,disb2m
      else
      write(lo,300)itot
      end if
  100 format(f10.4,'  - ',f10.4,i7,5f7.2,' |',i7,5f7.2)
  150 format(f10.4,'  - ',f10.4,i7,' |',i7)
  200 format(11x,a11,6x,'HIS',2x,'%INV',
     *      '  <er1> <w-er1>',' <er2> <w-er2>',' |',
     *      '   CUM',3x,'%INV',
     *      '  <er1> <w-er1>',' <er2> <w-er2>')
  250 format(11x,a11,6x,'HIS',3x,'CUM')
  300 format(24x,i7,5f7.2,/)

c     k2=len_trim(tirang(2))
c     if (k2==0) return
c----Plot the graph
c     strFile=fname(1)
c     k=index(strFile,'.')
c     k1=len_trim(tirang(1))
c     strFile=strFile(1:k-1)//'_'//tirang(2) (1:k2)//
c    * '_'//tirang(1) (1:k1)// '.gif/GIF'

c     ierPlot=PGOPEN(strfile)
c     if (ierPlot<=0) return
c     CALL PGSAVE
c     strHead(1)=tirang(1) (1:k1)
c     strHead(2)='d|PHI|'
c     strHead(3)=' '
c     icolor=0
c     CALL PGSCR(icolor,1.0,1.0,1.0)
c     icolor=1
c     CALL PGSCR(icolor,0.0,0.0,0.0)

c     npunti=0
c     do i=1,nrang
c      if (his(i) > 0) then
c      npunti=npunti+1
c      xplot(npunti)=range(i)
c      yplot(npunti)=cumerr1(i)/float(cumde(i))
c      endif
c     enddo

c     xmin=minval(xplot(1:npunti))
c     xmax=maxval(xplot(1:npunti))

c     ymin=minval(yplot(1:npunti))   
c     ymax=maxval(yplot(1:npunti))

c     if (ymax > 90. ) then
c       ymax=100.
c     else
c       ymax=90.
c     endif

c     CALL PGSCI(1)
c     CALL PGSLS(1)
c     CALL PGENV(xmin,xmax,0.0,ymax,0,-2)

c---- l'errore
c     CALL PGSLW(2) 
c     CALL PGLINE(npunti,xplot(1:npunti),yplot(1:npunti))
c     CALL PGSCH(2.0)
c     CALL PGPT(npunti,xplot(1:npunti),yplot(1:npunti),16)
c     CALL PGSCH(1.0)

c---- l'errore pesato
c     npunti=0
c     do i=1,nrang
c      if (his(i) > 0) then
c      npunti=npunti+1
c      xplot(npunti)=range(i)
c      yplot(npunti)=cumerp1(i)/ccmed(i)
c      endif
c     enddo

c     CALL PGSCI(2)
c     CALL PGSLS(1)
c     CALL PGSLW(2) 
c     CALL PGLINE(npunti,xplot(1:npunti),yplot(1:npunti))
c     CALL PGSCH(1.0)
c     CALL PGPT(npunti,xplot(1:npunti),yplot(1:npunti),9)
c     CALL PGSCH(1.0)

c     CALL PGSCI(1)
c     CALL PGSLW(3)
c     call PGBOX('BCNST',0.0,0,'BCNST',10.0,2)
c     CALL PGLAB(strhead(1),strHead(2),strHead(3))

c     CALL PGUNSA
c     call PGIDEN ! print info on the plot
c     CALL PGCLOS

      DEALLOCATE (dijs,iorde1, stat = ierr)

      return
      end
c--------------------------------------------------------------
      subroutine getstat(tirang,fc,fo,khl,dij,Nend,Ninit,ip1,ip2,
     +                  shi,c1,c,segni,nrang1,rmax1)

      USE General
      character tirang*80

      integer his(51),cumde(51)
      integer khl(3,Nend),ip1(Nend),ip2(Nend)
      real shi(4),range(51),disa1(51),sumfo(51),sumdiff(51),rfac1(51),
     *  rfac2(51),
     *  dsegni(51),csegni(51),sumfo2(51),sumdiff2(51),
     *  cumdew(51),disa1w(51),cumerr(51),cumerrw(51),cmed(51)
      real sumdiffs(51),sumdiff2s(51),rfac1s(51),rfac2s(51)

      real dij(Nend),c1(Nend),fo(Nend),fc(Nend),c(Nend),segni(Nend)

      integer,   allocatable     :: iorde(:)
      real,   allocatable        :: dijs(:)
c--
      allocate(iorde(Nend), dijs(Nend), stat=ierr)

      nrang=10
      ntot=count(c(Ninit:Nend) > 0.0)
      if (nrang1 > 0) then
         nrang=nrang1
      elseif (nrang1 < 0) then
         nrang=Ntot/abs(nrang1)
         nRifbin=abs(nrang1)
      endif

      rmin=999999.
      rmax=-999999.
      itot=0
      sumerr=0.0
      sumf1=0.0
      sumf2=0.0
      do 5 i=1,Nend
       dijs(i)=dij(i)
       iorde(i)=i
       if (c(i).le.0.0.or.c1(i).le.0.0) goto 5
       if (i.lt.Ninit) goto 5
       sumf1=sumf1+fo(i)
       sumf2=sumf2+fc(i)
       if (dij(i).lt.rmin) rmin=dij(i)
       if (dij(i).gt.rmax) rmax=dij(i)
    5 continue
      call sortall3(1,dijs,Ninit,Nend,iorde)

      write(6,*) 'Min,Max:',rmin,rmax
      scaleFoFc=sumf1/sumf2
      scaleFoFc=1.0
c     write(lo,*)'Scale=',scaleFoFc

      rmaxg=rmax
      if (rmax1.gt.0.0) rmax=rmax1
c     if (rmax.eq.0.0.and.rmin.eq.0.0) return
      dev=rmax-rmin
      iaa=nint(dev)
      rang=float(nrang)
      if (iaa.gt.0) then
         dev=float(iaa)/rang
      else
         dev=dev/rang
      endif
      range(1)=float(int(10.*rmin))/10.

      do i=2,nrang
         range(i)=range(i-1)+dev
      enddo
 
      range(1)=rmin
      range(nrang)=rmaxg

      his(:)=0
      cumde(:)=0.0
      cumdew(:)=0.0
      cumerr(:)=0.0
      disa1(:)=0.0
      disa1w(:)=0.0
      cmed(:)=0.0
      sumfo(:)=0.0
      sumdiff(:)=0.0
      sumdiffs(:)=0.0
      sumfo2(:)=0.0
      sumdiff2(:)=0.0
      sumdiff2s(:)=0.0
      rfac1(:)=0.0
      rfac2(:)=0.0
      rfac1s(:)=0.0
      rfac2s(:)=0.0
      dsegni(:)=0.0
      csegni(:)=0.0
c
      nu=0
      n=2
      sumerr=0.0
      sumw=0.0
      ii=0
      do 15 i=1,Nend
        k=iorde(i)
        if (k.lt.Ninit) goto 15
        if (c(k).le.0.0.or.c1(k).le.0.0) go to 15
        if (dijs(i).le.0.0) goto 15
        ii=ii+1
        jh=khl(1,k)
        jk=khl(2,k)
        jl=khl(3,k)
        fase=shi(4)*real(ip2(k))-360.*(jh*shi(1)+jk*shi(2)+
     *              jl*shi(3))
        errf=fase - real(ip1(k))
        errf=abs(amod(errf+3600.,360.))
        if (errf.gt.180.)errf=360.-errf
        sumerr=sumerr+errf
        sumw=sumw+c(k)
        if (nrang1 < 0) then
          if (ii==nRifbin) then
           range(n)=dijs(i)
           n=n+1
           ii=0
          else
           his(n)=his(n)+1
           disa1(n)=disa1(n)+errf
           disa1w(n)=disa1w(n)+errf*c(k)
           cmed(n)=cmed(n)+c(k)
           sumdiff(n)=sumdiff(n)+abs(fo(k)/scaleFoFc-fc(k))
           sumdiffs(n)=sumdiffs(n)+fo(k)/scaleFoFc-fc(k)
           sumfo(n)=sumfo(n)+abs(fo(k)/scaleFoFc)
           dsegni(n)=dsegni(n)+segni(k)
          endif
        else
   17    if (dijs(i).le.range(n)) then
           nu=nu+1
           his(n)=nu
           disa1(n)=disa1(n)+errf
           disa1w(n)=disa1w(n)+errf*c(k)
           cmed(n)=cmed(n)+c(k)
           sumdiff(n)=sumdiff(n)+abs(fo(k)/scaleFoFc-fc(k))
           sumdiffs(n)=sumdiffs(n)+fo(k)/scaleFoFc-fc(k)
           sumfo(n)=sumfo(n)+abs(fo(k)/scaleFoFc)
           dsegni(n)=dsegni(n)+segni(k)
         else
           nu=1
   23      n=n+1
           if(n.gt.nrang)n=nrang
           if (dijs(i).le.range(n)) then
             his(n)=nu
             disa1(n)=disa1(n)+errf
             disa1w(n)=disa1w(n)+errf*c(k)
             cmed(n)=cmed(n)+c(k)
             sumfo(n)=sumfo(n)+abs(fo(k)/scaleFoFc)
             sumdiff(n)=sumdiff(n)+abs(fo(k)/scaleFoFc-fc(k))
             sumdiffs(n)=sumdiffs(n)+fo(k)/scaleFoFc-fc(k)
             dsegni(n)=dsegni(n)+segni(k)
           else
             goto 23
           endif
         endif
        endif
   15 continue
      if (nrang1 < 0) nrang=n-1
      do 20 i=2,nrang
         itot=itot+his(i)
         if (his(i).ne.0) then
            if (sumfo(i).gt.0.0) then
              rfac1(i)=sumdiff(i)/sumfo(i)
              rfac1s(i)=sumdiffs(i)/sumfo(i)
            endif
            disa1(i)=disa1(i)/float(his(i))
            disa1w(i)=disa1w(i)/cmed(i)
            dsegni(i)=dsegni(i)/float(his(i))
            dsegni(i)=100.*dsegni(i)
         else
            disa1(i)=0.0
            disa1w(i)=0.0
            rfac1(i)=0.0
            dsegni(i)=0.0
         endif
   20 continue
      if (itot.le.0) return
c     write(6,*) sumerr/real(itot),itot,sumerr
      csegni(nrang)=his(nrang)*dsegni(nrang)
      cumde(nrang)=his(nrang)
      cumdew(nrang)=cmed(nrang)
      cumerr(nrang)=his(nrang)*disa1(nrang)
      cumerrw(nrang)=cmed(nrang)*disa1w(nrang)
      sumdiff2(nrang)=sumdiff(nrang)
      sumdiff2s(nrang)=sumdiffs(nrang)
      sumfo2(nrang)=sumfo(nrang)
      if (sumfo(nrang).gt.0.0) then
        rfac2(nrang)=sumdiff(nrang)/sumfo(nrang)
        rfac2s(nrang)=sumdiffs(nrang)/sumfo(nrang)
      endif
      do 30 i=2,nrang-1
      cumde(nrang+1-i)=cumde(nrang+2-i)+his(nrang+1-i)
      cumdew(nrang+1-i)=cumdew(nrang+2-i)+cmed(nrang+1-i)
      cumerr(nrang+1-i)=cumerr(nrang+2-i)+his(nrang+1-i)*
     * disa1(nrang+1-i)
      cumerrw(nrang+1-i)=cumerrw(nrang+2-i)+cmed(nrang+1-i)*
     * disa1w(nrang+1-i)
      csegni(nrang+1-i)=csegni(nrang+2-i)+dsegni(nrang+1-i)*
     * float(his(nrang+1-i))

      sumdiff2(nrang+1-i)=sumdiff2(nrang+2-i)+sumdiff(nrang+1-i)
      sumdiff2s(nrang+1-i)=sumdiff2s(nrang+2-i)+sumdiffs(nrang+1-i)
      sumfo2(nrang+1-i)=sumfo2(nrang+2-i)+sumfo(nrang+1-i)

      if (sumfo2(nrang+1-i).gt.0.0) then
          rfac2(nrang+1-i)=sumdiff2(nrang+1-i)/sumfo2(nrang+1-i)
          rfac2s(nrang+1-i)=sumdiff2s(nrang+1-i)/sumfo2(nrang+1-i)
      endif
   30 continue

      range(1)=rmin
      range(nrang)=rmaxg

      write(lo,200)tirang
      do 50 i=2,nrang
      if (his(i).eq.0) go to 50
      cumerr(i)=cumerr(i)/float(cumde(i))
      cumerrw(i)=cumerrw(i)/cumdew(i)
      csegni(i)=csegni(i)/float(cumde(i))
      write(lo,100) range(i-1),range(i),his(i),dsegni(i),disa1(i),
     +  disa1w(i),rfac1(i),rfac1s(i),cumde(i),csegni(i),cumerr(i),
     +  cumerrw(i),rfac2(i),rfac2s(i)
   50 continue
      write(lo,'(//)')
  100 format(f10.4,4h   -  ,f10.4,i6,1x,5f7.2,1x,1h|,1x,i6,1x,5f7.2)
  200 format(4x,a80)

      deallocate(iorde, dijs, stat=ierr)
      return
      end
c------------------------------------------------------------------
      subroutine disgen(tirang,dij,nrif,ic,diff,c,nrang1,rmax1)
      USE General
      integer his(51),cumde(51)
      real range(51),disa1(51),cumerr(51)
      real dij(nrif),diff(nrif),c(nrif)
      character tirang(2)*11
      integer, allocatable :: iorde(:)
      real, allocatable    :: dijs(:)


      allocate(iorde(nrif),dijs(nrif), stat=ierr)

c--
      nrang=10
      itot = 0
      if (nrang1.gt.0) nrang=nrang1
      rmin=999999.
      rabs=999999.
      rmax=-999999.
      do 5 i=1,nrif
       dijs(i)=dij(i)
       iorde(i)=i
       if (c(i).lt.0.001) goto 5
       if (i.lt.ic) goto 5
       if (dij(i).lt.rmin) rmin=dij(i)
       if (dij(i).gt.rmax) rmax=dij(i)
       if (abs(dij(i)).lt.rabs) rabs=abs(dij(i))
    5 continue
      call sortall3(1,dijs,ic,nrif,iorde)
      if (rmin.lt.0.0) then
                        rmax=amax1(rmax,abs(rmin))
                        rmin=-1.0*rmax
                       endif
      rmaxg=rmax
      if (rmax1.gt.0.0) rmax=rmax1
      dev=rmax-rmin
      iaa=nint(dev)
      rang=float(nrang)
      if (iaa.gt.0) then
                     dev=float(iaa)/rang
                    else
                     dev=dev/rang
                    end if
      if (rmin.ge.0.0) then
                        range(1)=float(int(10.*rmin))/10.
                        do i=2,nrang
                           range(i)=range(i-1)+dev
                        enddo
                       else
                        range(1)=float(nint(10.*rmin))/10.
                        nrangi=nint(float(nrang)/2.0)
                        nrang=2*nrangi
                        dev=rmax-rabs
                        dev=dev/rang
                        do i=2,nrangi-1
                           range(i)=range(i-1)+dev
                        enddo
                        range(nrangi)=-rabs
                        range(nrangi+1)=rabs
                        do i=nrangi+2,nrang
                           range(i)=range(i-1)+dev
                        enddo
                       endif
                  
c
      range(1)=rmin
      nrang=nrang+1
      range(nrang)=rmax
      range(nrang+1)=rmaxg
      do 10 i=1,51
         his(i)=0
         cumde(i)=0.0
         cumerr(i)=0.0
         disa1(i)=0.0
   10 continue
c
      n=2
      do 15 i=1,nrif
        k=iorde(i)
        if (k.lt.ic) goto 15
        if (c(k).le.0.0) go to 15
c---
   17   if (dijs(i).le.range(n)) then
                                  his(n)=his(n)+1
                                 else
                                  n=n+1
                                  if(n.gt.nrang)n=nrang+1
                                  goto 17
                                 endif
       disa1(n)=disa1(n)+diff(k)
   15 continue
      do 20 i=1,nrang+1
         itot=itot+his(i)
         if (his(i).ne.0) then
            disa1(i)=disa1(i)/float(his(i))
         else
            disa1(i)=0.0
         endif
   20 continue
      if (itot.le.0) goto 1000
      cumde(nrang+1)=his(nrang+1)
      cumerr(nrang+1)=his(nrang+1)*disa1(nrang+1)
      do 30 i=1,nrang
      cumde(nrang+1-i)=cumde(nrang+2-i)+his(nrang+1-i)
      cumerr(nrang+1-i)=cumerr(nrang+2-i)+his(nrang+1-i)*
     * disa1(nrang+1-i)
   30 continue
      write(lo,200)tirang(1)
      do 50 i=2,nrang+1
      if (his(i).eq.0) go to 50
      write(lo,100) range(i-1),range(i),his(i),disa1(i),
     * cumde(i),cumerr(i)/float(cumde(i))
   50 continue
  100 format(f10.4,4h   -  ,f10.4,i10,3x,f10.2,i8,f10.2)
  200 format(11x,a11,9x,'His',6x,a11,'Cum',a11)


 1000 continue

      deallocate(iorde,dijs, stat=ierr)

      return
      end
c-----------------------------------------------------------
      subroutine cumgen(delta,numbD)
      USE General

!     real delta(*)
      real    :: delta(nrefl)
      integer :: numbD
      real range(52),disde(52),range1(52),disde1(52)
      integer hisde(52),cumde(52)
      dimension vet(32),ivet(32)
      equivalence(vet(1),ivet(1))

      nrang=11
      do 5 i=1,nrang
         cumde(i)=0
         hisde(i)=0
         disde1(i)=0.0
         disde(i)=0.0
    5 continue
      rpm=0.0
      sumde=0.0
      rmin=99999.0
      rmax=-99999.0
      call sortall(1,delta,numbD)
      rmin=delta(1)
      rmax=delta(numbD)
      dev=rmax-rmin
      iaa=nint(dev)
      if (iaa.gt.0) then
                     dev=float(iaa)/10.
                    else
                     dev=float(nint(10.*dev))/100. 
                    end if
      range(1)=float(int(10.*rmin))/10.
      range(nrang)=float(nint(10.*rmax))/10.
      do 10 i=2,nrang-1
       range(i)=range(i-1)+dev
   10 continue
      range(1)=rmin
      range(nrang)=rmax
      m=2
      nn=0
      do 20 i=1,numbD
         sumde=sumde+abs(delta(i))
  17     if (delta(i).le.range(m)) then
                                    hisde(m)=hisde(m)+1
                                   else
                                    m=m+1
                                    if (m.gt.nrang) m=nrang
                                    goto 17
                                   endif
 20   continue
      cumde(nrang)=hisde(nrang)
      do 30 i=1,nrang-1
       cumde(nrang-i)=cumde(nrang+1-i)+hisde(nrang-i)
 30   continue
      range1(1)=rmin
      range1(nrang+1)=rmax
      disde1(1)=0.0
      disde1(nrang+1)=0.0
      do 40 i=2,nrang
       range1(i)=(range(i-1)+range(i))/2.0
       disde1(i)=real(hisde(i))/numbD
 40   continue
       disde(1)=(disde1(1)+disde1(2))/2.0
      do 50 i=2,nrang-2
       disde(i)=(disde1(i-1)+disde1(i)+disde1(i+1))/3.0
 50   continue
       disde(nrang-1)=(disde1(nrang-2)+disde1(nrang))/2.0
      demed=sumde/float(numbD)
c
      write(lo,1000)numbD
      write (lo,'(3x,7h<error>,21(1x,f8.2))')
     * range(1),(range(i+1),i=1,nrang-1)
      write (lo,'(4x,5hHisto,11x,i5,20(1x,i8))')
     * (hisde(i),i=2,nrang)
      write (lo,'(4x,5hCumul,2x,i5,20(1x,i8))')
     * (cumde(i),i=1,nrang)
      write(lo,'(/,4x,14h<  error  > = ,f6.2)')demed

      do i=1,nrang-1
       write(lo,*) range(i),range(i+1),hisde(i+1),cumde(i)
      enddo
c     call cstop(' ')
c
c
1000    format(//,6x,'distribution of  <error> ',
     *  'for',i6,' reflections  - number of ',
     *  '<error> .le. limit',/) 
      return
      end

*----------------------------------------------
      function pinvc (x)
      real k0,k1,k2,k3,k4,k5,k6
      data k0,k1,k2,k3,k4,k5,k6 / 0.499889, -0.389656, -0.0419407,
     *  0.137646, -0.0561208, 0.00955347, -0.000609217 /

      pinvc=k0+ k1*x + k2*x**2 + k3*x**3 +  k4*x**4 + k5*x**5 +  k6*x**6
      if (pinvc.lt.0.0) pinvc=0.0
      return
      end
*----------------------------------------------
      function pinvn (x)
      real k0,k1,k2,k3,k4
*===== APP
c     data k0,k1,k2,k3,k4 / 0.29, -7.26324, 64.5287, -241.268, 319.766 /
*===== BPO 
c     data k0,k1,k2,k3,k4 / ........ /
*===== CARP
c     data k0,k1,k2,k3,k4 / 0.03, -1.25324, 17.6034, -100.885, 202.256 /
*===== E2
      data k0,k1,k2,k3,k4 / 0.13, -5.4307, 76.2814, -437.17, 876.443 /
*===== NOX
c     data k0,k1,k2,k3,k4 / 0.18, -7.51943, 105.62, -605.312, 1213.54 /
*===== M-FABP
c     data k0,k1,k2,k3,k4 / 0.39, -6.98347, 38.0583, -42.2155, -111.219/

      if (x.le.0.2) then
          pinvn=k0+ k1*x + k2*x**2 + k3*x**3 +  k4*x**4
         else
          pinvn=0.0
         endif
      if (pinvn.lt.0.0) pinvn=0.0
      return
      end
*-----------------------------------------------------------------------
      function pinvt (x)
      real k0,k1,k2,k3,k4,k5,k6
*==== APP
c     data k0,k1,k2,k3,k4,k5,k6 / 0.483024, -0.80095, 0.516073,
c    *     -0.116208, 0.0,0.0,0.0 /
*==== BPO (Au)
c     data k0,k1,k2,k3,k4,k5,k6 / 0.475041, -0.538605, 0.932458,
c    *     -1.25469, 0.736421,-0.15246,0.0 /
*==== E2
      data k0,k1,k2,k3,k4,k5,k6 / 0.470809, -0.667487, -0.0787246,
     *      0.749581, -0.507624, 0.103277,0.0 /
*==== M-FABP
c     data k0,k1,k2,k3,k4,k5,k6 / 0.504771, -0.592854, 0.734417,
c    *     -0.892945, 0.539518, -0.112121,0.0 /
*==== NOX
c     data k0,k1,k2,k3,k4,k5,k6 / 0.508503, -0.0815326, -0.919659,
c    *      1.58289, -1.01797, 0.22352,0.0/

      pinvt=k0+ k1*x + k2*x**2 + k3*x**3 +  k4*x**4 + k5*x**5 +  k6*x**6
      if (pinvt.lt.0.0) pinvt=0.0
      return
      end
*----------------------------------------------------*
      subroutine gausfun(x,y)

      common/estmap/avden,stden,dumest(82)

*---- Gaussian distribution parameters ----*
      perc=0.9
      aver=avden
      sigma=perc*stden

      y=f_gaus(x,aver,sigma)

      return
      end

*---- funcion gausiana ----*
      function f_gaus(x,aver,sigma)

      pi=acos(-1.0)
      arg=(x-aver)**2 / (2.0*sigma**2)
      fact= 1.0/(sigma*sqrt(2.0*pi))
      f_gaus=fact*exp(-arg)

      return
      end
c-----------------------------------------------------------------------
*----------------------------*
*---- Calcola le distanze----*
*----------------------------*
      function dista(x1,x2)

      USE General
      real x1(3),x2(3),delta(3)


      do 10 i=1,3
        if (x1(i).lt.0.0) x1(i)=x1(i)-int(x1(i))+1.0
        if (x1(i).gt.1.0) x1(i)=x1(i)-int(x1(i))
        if (x2(i).lt.0.0) x2(i)=x2(i)-int(x2(i))+1.0
        if (x2(i).gt.1.0) x2(i)=x2(i)-int(x2(i))
        de1= abs(x1(i)-x2(i))
        de= min(abs(de1-1.0),de1)
        delta(i)= de*cell(i)
 10   continue

      cosa=cos(cell(4)*dtor)
      cosb=cos(cell(5)*dtor)
      cosg=cos(cell(6)*dtor)

      dist2=delta(1)**2 + delta(2)**2 + delta(3)**2 +
     &      2.0*delta(1)*delta(2)*cosg + 2.0*delta(1)*delta(3)*cosb +
     &      2.0*delta(2)*delta(3)*cosa

      dista=sqrt( dist2 )

      return
      end
c--------------------------------------------------------------------------
      subroutine pdcalc(sighp,RPMt,iTypeFunCT1)

      common /xalfa/ alfa, delta
      common /HistogramMatching/xcalc(500),ycalc(500),
     *        xoss(500),xoss_f(500),
     *        xcalcCT(500),ycalcCT(500),
     *        xofin(500),pdo(500),
     *        xcfin(500),pdc(500),
     *        ai(500),bi(500),
     *        npuntiOss,npuntiCal,npuntiCT,nsipCS,iTypeFunCT

      dimension ycalc2(500)
      iTypeFunCT = iTypeFunCT1
      alfa = sighp
      emin = 0.0
      emax = 50.0
c     emin = 0.01
c     emax = 10.0
      demin = -3.0
      demax =  3.0

      i=0

      delta=demin
      do while (delta <= demax)
         i=i+1
         if(delta.lt.0.0)emin=abs(delta)
         call qsimpHM(emin,emax,s)
         if(s.lt.0.00001)s=0.00
         xcalcCT(i)=delta
         ycalcCT(i)=s
         delta=delta + 0.1
      enddo

      npuntiCT=i
      RPMt=0.0
      deltaT=0.0
      call qsimp(demin,deltaT,sN,xcalcCT,ycalcCT,ycalc2,npuntiCT)
      call qsimp(deltaT,demax,sP,xcalcCT,ycalcCT,ycalc2,npuntiCT)
      RPMt=sp/sn

      return
      end
*-----------------------------------------------------------------------
      FUNCTION BESSI0_ORIG(X)
      REAL*8 Y,P1,P2,P3,P4,P5,P6,P7,
     *    Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9
      DATA P1,P2,P3,P4,P5,P6,P7/1.0D0,3.5156229D0,3.0899424D0,1.2067492D
     *0,
     *    0.2659732D0,0.360768D-1,0.45813D-2/
      DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7,Q8,Q9/0.39894228D0,0.1328592D-1,
     *    0.225319D-2,-0.157565D-2,0.916281D-2,-0.2057706D-1,
     *    0.2635537D-1,-0.1647633D-1,0.392377D-2/
      IF (ABS(X).LT.3.75) THEN
        Y=(X/3.75)**2
        BESSI0=P1+Y*(P2+Y*(P3+Y*(P4+Y*(P5+Y*(P6+Y*P7)))))
      ELSE
        AX=ABS(X)
        Y=3.75/AX
        BESSI0_ORIG=(EXP(AX)/SQRT(AX))*(Q1+Y*(Q2+Y*(Q3+Y*(Q4
     *      +Y*(Q5+Y*(Q6+Y*(Q7+Y*(Q8+Y*Q9))))))))
      ENDIF
      RETURN
      END

c----------------------------------
      function random1(ix,iy)
c ---
c ---computes uniformly distributed random real numbers between 0 and 1.
c ---
      iy=ix*65539
      if(iy)5,6,6
    5 iy=(iy+2147483647)+1
    6 random1=iy
      random1=random1*.4656613e-9
      return
      end

*-------------------------------------------------------
      subroutine matinvD(a,y,np,n)

      dimension indx(np)
      real*8  a(np,np), y(np,np), d


      do 12 i=1,n
        do 11 j=1,n
         y(i,j)=0.0
 11     continue
        y(i,i)=1.0
 12   continue
      call ludcmpD(a,n,np,indx,d)
      
      do 13 j=1,n
        call lubksbD(a,n,np,indx,y(1,j))
 13   continue

      return
      end
*------------------------------------------
      SUBROUTINE LUDCMPD(A,N,NP,INDX,D)
      PARAMETER (NMAX=500,TINY=1.0E-20)
      DIMENSION INDX(N)
      real*8 A(NP,NP),VV(NMAX), D
      real*8 AAMAX, SUM, DUM
      D=1.
      DO 12 I=1,N
        AAMAX=0.
        DO 11 J=1,N
          IF (ABS(A(I,J)).GT.AAMAX) AAMAX=ABS(A(I,J))
11      CONTINUE
c       IF (AAMAX.EQ.0.) PAUSE 'Singular matrix.'
        IF (AAMAX.EQ.0.) call cstop('Sing. mat. LUDCMPD')
        VV(I)=1./AAMAX
12    CONTINUE
      DO 19 J=1,N
        DO 14 I=1,J-1
          SUM=A(I,J)
          DO 13 K=1,I-1
            SUM=SUM-A(I,K)*A(K,J)
13        CONTINUE
          A(I,J)=SUM
14      CONTINUE
        AAMAX=0.
        DO 16 I=J,N
          SUM=A(I,J)
          DO 15 K=1,J-1
            SUM=SUM-A(I,K)*A(K,J)
15        CONTINUE
          A(I,J)=SUM
          DUM=VV(I)*ABS(SUM)
          IF (DUM.GE.AAMAX) THEN
            IMAX=I
            AAMAX=DUM
          ENDIF
16      CONTINUE
        IF (J.NE.IMAX)THEN
          DO 17 K=1,N
            DUM=A(IMAX,K)
            A(IMAX,K)=A(J,K)
            A(J,K)=DUM
17        CONTINUE
          D=-D
          VV(IMAX)=VV(J)
        ENDIF
        INDX(J)=IMAX
        IF(A(J,J).EQ.0.)A(J,J)=TINY
        IF(J.NE.N)THEN
          DUM=1./A(J,J)
          DO 18 I=J+1,N
            A(I,J)=A(I,J)*DUM
18        CONTINUE
        ENDIF
19    CONTINUE
      RETURN
      END
*-------------------------------------------
      SUBROUTINE LUBKSBD(A,N,NP,INDX,B)
      DIMENSION INDX(N)
      real*8 A(NP,NP),B(N)
      real*8 SUM
      II=0
      DO 12 I=1,N
        LL=INDX(I)
        SUM=B(LL)
        B(LL)=B(I)
        IF (II.NE.0)THEN
          DO 11 J=II,I-1
            SUM=SUM-A(I,J)*B(J)
11        CONTINUE
        ELSE IF (SUM.NE.0.) THEN
          II=I
        ENDIF
        B(I)=SUM
12    CONTINUE
      DO 14 I=N,1,-1
        SUM=B(I)
        DO 13 J=I+1,N
          SUM=SUM-A(I,J)*B(J)
13      CONTINUE
        B(I)=SUM/A(I,I)
14    CONTINUE
      RETURN
      END
*------------------------------------
       subroutine det(a,np,n,d)

       dimension indx(np)
       real*8 a(np,np), d

       call ludcmpd(a,n,np,indx,d)

       do 10 j=1,n
         d=d*a(j,j)
 10    continue

       return
       end
c--------------------------------------------
c------Check Distances in a set of atoms
c--------------------------------------------

      subroutine CheckDistanceAtoms(xa,nza,natsDist)
      USE General
      USE Symmetry
      dimension xa(5,500),nza(500)

      dimension x1(3),x2(3)

      do 10 i=1,natsDist
      itp=iabs(nza(i))
      if (itp > 100) itp=mod(itp,100)
      if (itp.ne.0) then
         do j=1,3
          if (xa(j,i).lt.0.0) xa(j,i)=xa(j,i)-int(xa(j,i))+1.0
          if (xa(j,i).ge.1.0) xa(j,i)=xa(j,i)-int(xa(j,i))
         enddo
         itp=nalfd(itp)
c        write(lo,1000) itp,i,xa(5,i),xa(4,i),(xa(j,i),j=1,3)
      endif
 10   continue
 1000 format('atom ',a2,i4,5x,5f10.4)

      call prepeqv

      do 20 i=1,natsDist
       itp=iabs(nza(i))
       if (itp.eq.0) goto 20
       x1(1)=xa(1,i)
       x1(2)=xa(2,i)
       x1(3)=xa(3,i)

         do 30 ii=i+1,natsDist
          itp=iabs(nza(ii))
          if (itp.eq.0) goto 30
          xx=xa(1,ii)
          yy=xa(2,ii)
          zz=xa(3,ii)

          do 40 k=1,nsym
           call oper(k,x2,xx,yy,zz)
           dd = dista(x1,x2)
c          print*,x1
c          print*,x2
c          print*,cell
           if (dd < 6.) then
c            print*,i,ii,k,dd
           endif

 40       continue
 30      continue
 20    continue


       return
       end
c-------
      function dista3(x1,x2)


      USE General
      dimension x1(3),x2(3),diff(3),sottr(3),r(3)
      dimension ang(3),g(3,3)

      do 31 ki=1,3
      ang(ki)=((pi*cell(ki+3))/180.0)
   31 continue

      g(:,:)=0.0

      do 50 i=1,3
      do 60 j=1,3
      if(i.eq.j)then
                g(i,j)=g(i,j)+cell(i)*cell(j)
                goto 65
                end if
      i1=abs(i-j)
      if(i1.eq.2)then
                 g(i,j)=g(i,j)+cell(i)*cell(j)*cos(ang(2))
                 goto 65
                 end if
      if((i.eq.1.and.j.eq.2).or.(i.eq.2.and.j.eq.1))then
                 g(i,j)=g(i,j)+cell(i)*cell(j)*cos(ang(3))
                 goto 65
                 end if
      g(i,j)=g(i,j)+cell(i)*cell(j)*cos(ang(1))
 65   continue
 60   continue
 50   continue


       do 10 j=1,3
         diff(j)=x1(j)-x2(j)
         sottr(j)=abs(diff(j))
         if (sottr(j).gt.0.6) then
            diff(j)=x1(j)+1.0-x2(j)
            sottr(j)=abs(diff(j))
            if (sottr(j).gt.0.6)then
               diff(j)=x1(j)-1.0-x2(j)
               sottr(j)=abs(diff(j))
            end if
         end if
 10    continue

       r(:)=0.0
       do j=1,3
        do i=1,3
          r(j)=r(j)+sottr(i)*g(i,j)
        enddo
       enddo

       v=sum(sottr(1:3)*r(1:3))

       dista3=sqrt(v)


       return
       end
c-------------------------------
      SUBROUTINE avevar(data,n,ave,var)

      INTEGER n
      REAL ave,var,data(n)
      INTEGER j
      REAL s,ep
c     REAL, DIMENSION(:), INTENT(IN) :: data
c     REAL, INTENT(OUT) :: ave,var
c     INTEGER  :: n
c     REAL, DIMENSION(size(data)) :: s

c     n=size(data)
      ave=sum(data(1:n))/n

      var=0.0
      ep=0.0
      do 12 j=1,n
        s=data(j)-ave
        ep=ep+s
        var=var+s*s
12    continue
      var=(var-ep**2/n)/(n-1)
      return
      END
c--------------------------------------
c     SUBROUTINE avevar(data,ave,var)
c     USE nrtype
c     IMPLICIT NONE
c     REAL(SP), DIMENSION(:), INTENT(IN) :: data
c     REAL(SP), INTENT(OUT) :: ave,var
c     INTEGER(I4B) :: n
c     REAL(SP), DIMENSION(size(data)) :: s
c     n=size(data)
c     ave=sum(data(:))/n
c     s(:)=data(:)-ave
c     var=dot_product(s,s)
c     var=(var-sum(s)**2/n)/(n-1)
c     END SUBROUTINE avevar
c--------------------------------------------------------------------------
      subroutine VecchiaExamin()
      USE Symmetry
      dimension step(3)
!
      npol = 0
      tabo = 0
      do i=1,3
         if (vpol(i) == 1) then
             tabo(1:8,i) = 256
             step(i) = 1.0
         else
             step(i) = 0.5
         endif
      enddo
**    do x = 0.0, 0.6, step(1)
**       do y = 0.0, 0.6, step(2)
**          do z = 0.0, 0.6, step(3)
      x = 0.0
      do while(x <= 0.6)
         y = 0.0
         do while(y <= 0.6)
            z = 0.0
            do while(z <= 0.6)
               nOrigRoxi = nOrigRoxi + 1
               if (vpol(1) == 0) then
                   tabo(nOrigRoxi,1) = x
               endif
               if (vpol(2) == 0) then
                   tabo(nOrigRoxi,2) = y
               endif
               if (vpol(3) == 0) then
                   tabo(nOrigRoxi,3) = z
               endif
               z = z + step(3)
            enddo
            y = y + step(2)
         enddo
         x = x + step(1)
      enddo
!
      return
      end
*---------------------------------------------------------
      subroutine ReadFileAscii(namefile,ier)

      USE General
      USE IsrCom
      USE Riflessi
      USE DemiFlunch


      character*200 namefile,dire,formt
      character*250 buffer

      dimension vet(40),ivet(40),shi2(4),i1(3)

      write(lo,*)
      write(lo,*)' ============================================'
      write(lo,'(" Read file   : ",a)')namefile(1:Lung(namefile))

      ifat1=(2*ihmxExt(3)+1)*(2*ihmxExt(2)+1)
      ifat2=(2*ihmxExt(3)+1)
      ifatx=ihmxExt(1)*ifat1+ihmxExt(2)*ifat2+ihmxExt(3)
      
      IF (.NOT. ALLOCATED(isr)) then
         allocate (isr(1:ifatx),stat=ier)
      else
         deallocate(isr,stat=ier)
         allocate (isr(1:ifatx),stat=ier)
      endif
      isr(:)=0
      work1(:)=0.0
      work2(:)=-1.0
      rhomaxRead = -999.0
      rhominRead = 999.0

      rhomaxOrig = maxval(rhov(1:nreflTot))
      rhominOrig = minval(rhov(1:nreflTot))
c     dminRead = minval(dreso(1:nreflTot))
c     dmaxRead = maxval(dreso(1:nreflTot))

      do i=1,nreflTot
        ih1=khl(1,i)
        ik1=khl(2,i)
        il1=khl(3,i)
        inbl=ih1*ifat1+ ik1*ifat2 + il1
        inbl=iabs(inbl)
        ib1=1
        if(il1) 590,570,600
  570   if(ih1) 590,580,600
  580   if(ik1) 590,600,600
  590   ib1=-1
  600   continue
        isr(inbl)=i*ib1
      enddo

      formt='(3i4,2f12.4)'

      open(1,file=namefile,status='old',err=9000)
      ic=0
      iend=0
 10   read(1,'(a)',end=50) buffer
         if (iend.eq.1) goto 20
         call cutst(buffer,lenp,dire,lend)
         call lcase(dire)
         iopt=0
c        call getnum(buffer,vet,ivet,iv,iopt)
         if (dire(1:4).eq.'data') then
            iend=1
         elseif (dire(1:4).eq.'form') then
             k=index(dire,'(')
             formt=dire(k:k+39)
         else
            goto 10
         endif
      goto 10
 20   continue
      if (buffer(1:1).eq.'>') goto 10
      if (buffer(1:1).eq.'<') goto 10
      if (buffer(1:1).eq.'#') goto 10
      if (ifDemiFL == 0) then
        read(buffer,formt) ih1,ik1,il1,f1,ph1
        call geneq(0,ih1,ik1,il1,idelt,jcode,isgnn,id1,rho2,ireje)
        iph1=nint(ph1)
        iph1=iph1+idelt
        iph1=iph1*isgnn
        iph1=mod(iph1+3600,360)
        if(iph1.le.0) iph1=iph1+360
      else
c       read(buffer,formt) rp1,rp2,rp3,f1,ph1
        read(buffer,formt) ih1,ik1,il1,f1,ph1
        rp1 =  ih1/2.0
        rp2 =  ik1/2.0
        rp3 =  il1/2.0
        jcode1=jDemiRef(rp1,rp2,rp3)
        if (jcode1 /= jcodeDFL) goto 10
c       if (jcode1 /= 0) goto 10
        rho2=rhofreal(pp,rp1,rp2,rp3)
        rho2 = rho2**2
        ih1 = nint(nDemiH*rp1)
        ik1 = nint(nDemiK*rp2)
        il1 = nint(nDemiL*rp3)
        iph1 =nint(ph1)
        iph1=mod(iph1+3600,360)
        if(iph1.le.0) iph1=iph1+360

        if (ih1.lt.0.0) then
           ih1 = -ih1
           ik1 = -ik1
           il1 = -il1
           iph1=-iph1
        endif
        !
      endif

      indr=ih1*ifat1+ik1*ifat2+il1
      indrr=iabs(indr)
      if (indrr.gt.ifatx) goto 10
      kk=iabs(isr(indrr))
      if (kk.le.0) goto 10
c     dresRead = 0.5/sqrt(rho2)
      if (rho2 < rhominOrig) goto 10
      if (rho2 > rhomaxOrig) goto 10
      if (rho2 > rhomaxRead ) rhomaxRead = rho2
      if (rho2 < rhominRead ) rhominRead = rho2
      ic=ic+1

      work1(kk)=iph1
      work2(kk)=f1
      idif = abs(iph1-ipub(kk))
c     if (kk <= nrefl.and.idif > 1) 
c     if (kk <= nrefl) 
c    *      write(3,'(i5,f6.2,3i4,3i5)')kk,0.5/sqrt(rho2),
c    *     ih1,ik1,il1,iph1,ipub(kk),idif
c     write(3,'(3f6.1,2f12.4)')rp1,rp2,rp3,f1,ph1

      goto 10
 50   close(1)
      write(lo,'(" Read        :",i6," reflections")')ic
      write(lo,'(" Res(A) range: ",f6.2, " - ",f6.2)')
     *          0.5/sqrt(rhomaxRead),0.5/sqrt(rhominRead)
c     rhomaxOrig = maxval(rhov(1:nreflTot))
c     rhominOrig = minval(rhov(1:nreflTot))

      write(lo,'(" Observed    : ",i6," reflections")')nreflTot
      write(lo,'(" Res(A) range: ",f6.2, " - ",f6.2)')
     *          0.5/sqrt(rhomaxOrig),0.5/sqrt(rhominOrig)

      write(lo,*)' ============================================'
      write(lo,*)

c     do i=1,nreflTot
c       if (work2(i) < 0) then
c        write(6,*)khl(1:3,i),fovet(i)
c       endif
c     enddo

c     stop


      return

 9000 ier=-1

      return
      end
!-----------------------------------------------------------------------
      subroutine Modifica_Wt(numbCut1,numbCut2)
      USE General
      USE Riflessi
!
      common /conue/ shi(4),ishi,shi1(4)
      dimension nrif_perc(2), iperc(2)
      character*80 tirang

!

      if (knw == 1) then
        tirang = 'Wt prima'
        call ParamDistribution(tirang,2,wt,khl,numbCut2,numbCut1,
     *       ipub,iphaz,shi1,wt,segni1,20,1.0)
      endif

      sogWt1=0.1
      sogWt2=0.9

      nrif_perc(:) = 0
      iperc(:) = 0
      numbCut = numbCut2 - numbCut1 + 1

      do i=numbCut1,numbCut2
         if (wt(i) > sogWt2) then
             nrif_perc(1) = nrif_perc(1) + 1
         elseif (wt(i) < sogWt1) then
             nrif_perc(2) = nrif_perc(2) + 1
         endif
      enddo

      rap1 = float(nrif_perc(1)) / float(numbCut)
      rap2 = float(nrif_perc(2)) / float(numbCut)
      if (rap1 > 0.3) iperc(1) = 1
      if (rap2 > 0.3) iperc(2) = 1
      write(6,*)'perc',iperc(1),rap1,iperc(2),rap2
      itotperc = iperc(1) + iperc(2)     

      nCicliModifica = 0
      nCicliExit = 3

      do while (itotperc /= 0)

         nCicliModifica =  nCicliModifica + 1
         if (iperc(1) == 1) then
            do i=numbCut1,numbCut2
               gsim = besinv(wt(i))
               gsim = gsim * 0.75
               wt(i)= bes(gsim)
            enddo
         endif
         if (iperc(2) == 1) then
            do i=numbCut1,numbCut2
               gsim = besinv(wt(i))
               gsim = gsim * 1.5
               wt(i)= bes(gsim)
            enddo
         endif


         nrif_perc(:) = 0
         iperc(:) = 0
         do i=numbCut1,numbCut2
            if (wt(i) > sogWt2) then
                nrif_perc(1) = nrif_perc(1) + 1
            elseif (wt(i) < sogWt1) then
                nrif_perc(2) = nrif_perc(2) + 1
            endif
         enddo

         rap1 = float(nrif_perc(1)) / float(numbCut)
         rap2 = float(nrif_perc(2)) / float(numbCut)
         if (rap1 > 0.3) iperc(1) = 1
         if (rap2 > 0.3) iperc(2) = 1
         itotperc = iperc(1) + iperc(2)
         write(6,*)'perc',iperc(1),rap1,iperc(2),rap2
         if (nCicliModifica == nCicliExit) exit

      enddo !(itotperc == 0)

      if (knw == 1) then
        tirang = 'Wt dopo mod'
        call ParamDistribution(tirang,2,wt,khl,numbCut2,numbCut1,
     *       ipub,iphaz,shi1,wt,segni1,20,1.0)
      endif
      stop
!
!
      return
      end
!-----------------------------------------------------------------------
      subroutine sortallM(isort,x,ic,ict,numbx,numb,iorde)
      dimension x(ict,numb),iorde(numb)

c--- isort=-1 ===> decrescente
c--- isort= 1 ===> crescente

      if(numb.eq.1) return
      m=2
  10  continue
      in=numb/m
      if(in) 20,20,30
  20  continue
      in=1
  30  continue
      ifin=numb-in
  40  continue
      mark=0
      do 60 i=1,ifin
      if (i.lt.numbx) goto 60
      k=i+in
      if (isort.lt.0) then
         if(x(ic,i)-x(ic,k)) 50,60,60
      else
         if(x(ic,k)-x(ic,i)) 50,60,60
      endif
  50  continue
      do kk=1,ict
       dd=x(kk,i)
       x(kk,i)=x(kk,k)
       x(kk,k)=dd
      enddo
      id=iorde(i)
      iorde(i)=iorde(k)
      iorde(k)=id
      mark=1
  60  continue
      if(mark) 65,65,40
  65  continue
      if(in-1) 80,80,70
  70  continue
      m=m*2
      go to 10
  80  continue
      return
      end
!-------------------------------------------------------
      subroutine e2stat
      USE General
      USE Symmetry
      USE Riflessi
      real,  allocatable    :: shellTAB(:,:),midpts(:)
      real,  allocatable    :: Eo2Shell(:),scEo2Shell(:)
      integer,  allocatable :: RES_TAG(:)



      Nbin=30
      Nstat=floor(nrefl/float(Nbin))
      Nbin=8.0*alog10(0.05*float(max0(nrefl,100))+0.5)

      allocate (RES_TAG(nrefl), shellTAB(Nbin,2),
     *         Eo2Shell(Nbin),midpts(Nbin),
     *         scEo2Shell(Nbin),
     *         stat=ierr)

      shellTAB(:,:)=0.0
      midpts(:)=0.0
      RES_TAG(:)=0
      call shells(shellTAB,midpts,RES_TAG,dreso,nrefl,Nbin,1) 

      Eo2Shell(:)=0.0

      ! calc Eo, Ec
      do i=1,nrefl
       ii=RES_TAG(i)
       Eo2Shell(ii)= Eo2Shell(ii)+evet(i)**2
      enddo

      ! calc <Eo2> for any shell
      do i=1, Nbin
        numbShell1=count(RES_TAG(:) == i)
        Eo2Shell(i)=Eo2Shell(i)/float(numbShell1)
        scEo2Shell(i)=Eo2Shell(i)/1.0
        write(6,*)midpts(i),numbShell1,Eo2Shell(i)
      enddo
      

      do i=1,nrefl
        ii=RES_TAG(i)
        ee1=evet(i)/sqrt(scEo2Shell(ii))
        if (dreso(i) > 8.0) evet(i)=ee1
      enddo


      return
      end
