!-----------------------------------------------------------------------
      subroutine getplt(jump, inMemoryOnly, ier)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom     
      USE PhaseModule
      USE RemoModule
!
!-- get peaks to plot
!
!-- inMemoryOnly = 0   destroy old atoms (list 5)
!-- inMemoryOnly = 1   retain  old atoms (list 5)
      character*4 diret
      character*6 a6
      character*80  line,dire
      dimension ivet(20),vi(40),vet(40) ,lini(40),iv(40)
      dimension xo(11),xn(11),key(10)
      dimension xyzsS(5)
      character (len=4) :: SpeciesTmp(18)
c
c--parameter   x y z occ int ty serial
c--code number 1 2 3  5   4  6   7
c--call for test per lettura file z-matrix
c      itest=1
c	if(itest.eq.1) then
c      icodZ=1
c      call readzmat(icodZ,ier)
c	return
c	endif
c--fine test
c
      do i=1, nk
         SpeciesTmp(i) = Species(i)
         call lcase(SpeciesTmp(i))
      enddo
      NumLeg = 0
      NatMol = 0
      NatSpi = 0
      xo(:)  = 0
      xn(:)  = 0
      key(:) = 0
      if (bt < 0.001) then
          bt = 3.0
      endif
      itype = 1
      iform = 2
      jop = jopen(jgrap,'  ',itype,iform,ier)
      if (jop < 0) then
          ier = -1
          return
      endif
      if (inMemoryOnly == 0) then
          ilist = 5
          call Cancella(ilist)
          ilist = 12
          call Cancella(ilist)
      endif
!
      if (InfoOK(3).eq.0) then
          nk = 0
      endif
      nSpec = 0
      nSpecie = 0
      ottopi2 = 8.0 * pi * pi
      nats = 0
      do j=1,40
         lini(j) = 0
      enddo
      xyzsS(:) = 0.0
c
      in      = 4
      lini(1) = 6
      lini(2) = 1
      lini(3) = 2
      lini(4) = 3
c
      do 5 j=1,in
         ivet(j)=0
         nnn=j
         ivet(j)=lini(j)
         if (lini(j).gt.0.and.lini(j).le.7) go to 5
         n=j-1
    5 continue
      jtype=0
      if (ivet(1).eq.6) then
          jtype=1
          do 10 j=1,nnn-1
   10     ivet(j)=ivet(j+1)
          ivet(nnn)=0
          nnn=nnn-1
      endif
  100 nats=nats+1
      izz=6
      read(jhost,'(a)',end=300,iostat=ios)line
      call shift(line,kk)
      if (line(1:4).eq.'    ') then
          nats = nats - 1
          goto 100
      end if
      if (line(1:1).eq.'>' .or. line(1:1).eq.'!') then
          nats = nats - 1
          goto 100
      end if
      if (jtype.eq.1) then
          call cutst(line,lenp,dire,lend)
          call lcase(dire)
          if (lend.gt.2) go to 106
          iOK = 0
          do j=1, nk
             if (dire == SpeciesTmp(j)) then
                 izz = no(j)
                 iOK = 1
             endif
          enddo
          if (iOK.eq.0) then
              call AnalysisSpecies(nSpec,izz,dire,ier)
          endif
!
  106     continue
      endif
      nzS = izz*nzConst+1
      iopt=0
      call getnum(line,vi,iv,in,iopt)
      do 110 j=1,nnn
         if (ivet(j).eq.0) go to 110
         if (ivet(j).lt.6) then
             xyzsS(ivet(j)) = vi(j)
         endif
  110 continue
      if (in.gt.3) then
*         xyzs(5,nats)=vi(4)
cmodh
c         xyzsS(5) = vi(4)
          if(vi(4)<0.5) then
c-allora sono u
            xyzsS(5) = vi(4)*ottopi2
          else
c-in effetti sono b
            xyzsS(5) = vi(4)
          endif
cmodh
      else
*         xyzs(5,nats)=bt
          xyzsS(5) = bt
      endif
      if (in.gt.4) then
*         occsav(nats)=vi(5)
          occS = vi(5)
      else
*         occsav(nats)=1.0
          occS = 1.0
      endif
      write(jgrap) xyzsS, nzS, occS 
      go to 100
  300 nats=nats-1
!      
!-- allocate Atomi module and fill arrays from jgrap
!
      if (inMemoryOnly == 0) then
          natsSav = nats
          call AllocaAtomi(2)
          nats = natsSav
          call AllocaAtomi(1)
      endif
      iconn(1) = -9999
      rewind jgrap
      do i=1, nats
         read(jgrap) xyzs(1,i), xyzs(2,i), xyzs(3,i),
     *               xyzs(4,i), xyzs(5,i), nz(i), occsav(i) 
         SinglePlotType(i) = SIMPLE
         xyLab(1,i) = 0.0
         xyLab(2,i) = 0.0
         nOpEq(i)   = 1555
         iEqui(i)   = i
         serial(i)  = i
      enddo
      bfac(1:nats) = xyzs(5,1:nats)
      close(jgrap)
!
      if (InfoOK(1) == 0) then
          i = 0
          call Get_1_2(i, ier)
      endif
      if (InfoOK(3).ne.0) then
          do j=1,nats
             izz=nz(j)/nzConst
             iOk = 0
             do k=1,nk
                if (izz.eq.no(k)) then
                    nz(j)=k*nzConst+1
                    xyzs(4,j)=izz*100+k
                    iOk = 1
                endif
             enddo
             if (iOk == 0 .and. QualePgm == SIRPROTPGM) then
                 izz = no(nk)
                 nz(j) = nk * nzConst + 1
                 xyzs(4,j)=izz*100+nk
             endif
          enddo
          if (nats.gt.1.and.jump.eq.0) then
              call sortf(xyzs, 5, nats, 4)
          endif
          do j=1,nats
             a = xyzs(5,j)
             xyzs(5,j) = occsav(j)
             bfac(j) = a
          enddo
          do j=1,nats
             k=xyzs(4,j)
             k=mod(k,100)
             nz(j)=k*nzConst+1
          enddo
          if (jump == 0) then
              call xspinb
              iactn=1
              do j=1,nats
                 xo(1)=xyzs(1,j)
                 xo(2)=xyzs(2,j)
                 xo(3)=xyzs(3,j)
                 itype = iabs(nz(j)/nzConst)
                 if (itype == 0) then
                     if (nSpec == 0) then
                         Msg = 'Check fragment file content'
                     else
                         a6 = '"' // vSpecie(1) // '"'
                         call NoBlanks(a6,ls)
                         Msg = 'Atomic species ' // a6(1:ls) //
     *                         ' not in unit cell content'
                     endif
                     call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
                     ier = -1
                     return
                 endif
                 itype = nalf( itype )
                 iser=j
                 iactn=1
                 khead=0
                 ksp=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
                 xyzs(5,j) = 1.0/float(key(10))
              enddo
c--- bisogna riassemblare la molecola.
              if (neutro == 1) then
                  xyzNeutrons(1:5,1:nats) = xyzs(1:5,1:nats)
              endif
              kact=5
              kblock(1:nats) = 1
              call build(kact, 2)
c
c-- creates Labels and writes List 15
c
              iniz = 1
              ifin = nats
              call MakeLab(iniz,ifin)
c
              BTot(1,1) = 101.0
              interp = 1
              call PutGetXyzs(1, interp)
!
          else
              iniz = 1
              ifin = nats
              call MakeLab(iniz,ifin)
          endif
***       call ScriviFrammento()
!
          if (jpfile.lt.0.or.jump.eq.1) then
              do j=1,nats
                 nz(j) = nz(j) / nzConst
              enddo
          endif
      endif
      NumSpec = nSpec
!
      WhichModel = 1
      MonomerInModel(WhichModel) = 1
      call PutModel
      call toflush()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AnalysisSpecies(nSpec,izz,dire,ier)
!--analizza quali specie sono presenti nella lista atomica
!
      USE General
!
      character*(*) dire
!
      if (nSpec.eq.0) then
          nSpec = nSpec + 1
          vSpecie(nSpec) = dire(1:2)
          nSpecie(nSpec) = 1
          izz = nSpec
      else
          iok=0
          do j=1,nSpec
             if (vSpecie(j).eq.dire(1:2)) then
                 iok=1
                 nSpecie(j) = nSpecie(j) + 1
                 izz = j
                 exit
             endif
          enddo
          if (iok.eq.0) then
              nSpec = nSpec + 1
              vSpecie(nSpec) = dire(1:2)
              nSpecie(nSpec) = 1
              izz = nSpec
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiCIF(ifRefl, inMemoryOnly, ier)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE CIF
      USE RemoModule
      USE PhaseModule
      USE SAmodule
      USE unit_cell
!
!-----legge le informazioni strutturali dal file *.cmf prodotto dal CSDS 
!-----(Cambridge Structural Database System) by Roxi
!-----legge le informazioni strutturali dal file *.cif 
!
      implicit none
      integer :: ifRefl, inMemoryOnly, ier, zero, jj, n_a
      integer :: i, j, k, ishif, ksp, kspecb, iser, iactn, khead
      integer :: nExitCode
      real    :: wave, TotOcc, ChemicalOcc, occ, ortop(3,3)
!
      integer :: kshif(3), b_or_u, nk_lcase, sincronizza, key(10)
      integer :: n, iniz, ifin, itype, ifMsg, ifSPG, iprint, nSymCard 
      real    :: sumOcc(18), celltemp(13), x1(3), x2(3), xo(11), xn(11)
      character dum1, dum2, a4*4, Species_lcase(18)*4
      character Label*16
      character*4 ions(2,18)
      character (len=4) :: SpeciesTmp(18)
!
      sincronizza = 0
*gl*  vSpecie(1:18) = Species(1:18)
      SpeciesTmp(1:18) = vSpecie(1:18)
      Species_lcase(1:18) = vSpecie(1:18)
      nk_lcase = nk
      do i=1, 18
         call lcase(Species_lcase(i))
      enddo
      ishif = 0
      kshif(:) = 0
      wave = 0.71073
      ifRefl = 0
      xo(:) = 0
      xn(:) = 0
      key(:) = 0
      nk = 0
      Species(:) = ' '
      b_or_u = 0
      call LeggiCIFinMem(ifSPG, ifRefl, nats, celltemp, iprint, 
     *                   b_or_u, nSymCard, wave, ier)
      cellaFrag(1:6) = celltemp(1:6)
!
      if (ier < 0) then
          return
      endif
!
      if (iprint > 0) then
          do i=1,nk
             write(6,*) i,' ',species(i),' ',cif_number(i)
          enddo
      endif
      if (inMemoryOnly == 0) then
!
!-- Store cell parameters
!
          if (InfoOK(1) == 0) then
               call CreaCellInfo(celltemp)
          endif
!
!-- Store symmetry information
!
          if (InfoOK(2) /= 1) then
              if (ifSPG == 0) then
                  jj = InfoOK(1)
                  call Get_1_2(jj, ier)
                  if (ier < 0) then
                      return
                  endif
              endif
              call CreaSymmetryInfo(ier)
              if (ier < 0) then
                  return
              endif
              if (nsym == 1 .and. icent == 0) then
                  ifReduced = 0
              endif
              nsymTrue = nsym
              call xspinb
          endif
!
!-- Store unit cell content
!
           ifMsg = 1
           call CheckIons(ifMsg, ions)
           if (InfoOK(3) == 0) then
               wavel = wave
               do i=1, 18
                  nw(i) = nint( totop * cif_number(i) )
               enddo
               Species_lcase(1:18) = vSpecie(1:18)
               ifMsg = 1
               call CheckIons(ifMsg, ions)
               call CreaAtmPropInfo(WhichProps, ier)
               if (ier < 0) then
                   Msg = 'Check coordinates in CIF file'
                   call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
                   return
               endif
*gl*           vSpecie(1:18) = Species(1:18)
               call GetFromAtmStruct
*gl*           Species_lcase(1:18) = Species(1:18)
*gl*           Species(1:18) = vSpecie(1:18)
               vSpecie(1:18) = Species_lcase(1:18)
               sincronizza = 1
               call InitMolplo()   ! spostato da sotto 
           else
               sincronizza = 1          !!!! ?????
           endif
           if (ier < 0) then
               nats = 0
               return
           endif
      else
*gl*       sincronizza = 1
      endif
!
!-- Allocate Atomi module and fill arrays from jgrap
!
      if (inMemoryOnly == 0) then
          WhichModel = 1
          numbModels = 1
          k = nats
          call AllocaAtomi(2)
          nats = k
          call AllocaAtomi(-1)
          natsInModel(WhichModel) = MaxAtoms
          MonomerInModel(WhichModel) = 1
      endif
      call AllocaModelRemo(1)
!
      rewind jgrap
!
!-- Store atom information
!
*gl*  call InitMolplo()   ! spostato sopra se InfoOK(3)=0
      if (inMemoryOnly == 0) then
          do i=1, nk
             Species_lcase(i) = Species(i)
             call lcase(Species_lcase(i))
          enddo
*     else
*         do i=1, nkSav
*            write(Species_lcase(i),'(a4)') nalfSav(i)
*            call lcase(Species_lcase(i))
*         enddo
      endif
      model(WhichModel)%BTot(:,:) = 0
      model(WhichModel)%BTot(1,1) = 1
      model(WhichModel)%BTot(2,2) = 1
      model(WhichModel)%BTot(3,3) = 1
      sumOcc(:) = 0.0
      do i=1, nats
!gl!     read(jgrap) aLab(i), a4, xyzs(1,i), xyzs(2,i), xyzs(3,i),
!gl! *                   ChemicalOcc, IsoAniso(i), bfac(i), serial(i)
         read(jgrap) model(WhichModel)%Label(i),
     *               a4,
     *               model(WhichModel)%atoms(1:3,i,1),
     *               ChemicalOcc,
     *               IsoAniso(i),
     *               model(WhichModel)%th_fact(i,1),
     *               model(WhichModel)%serial(i)
!
         xo(1:3) = model(WhichModel)%atoms(1:3,i,1) 
         model(WhichModel)%IsoAniso(i,1) = IsoAniso(i)
         itype = 1
         iser=i
         iactn=1
         khead=0
         ksp=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
         TotOcc = ChemicalOcc / float( key(10) )
         model(WhichModel)%atoms(5,i,1) = TotOcc

*        go to 222

         do j=1, nk
            if (a4 == ions(1,j)) then
                a4 = ions(2,j)
                exit
            endif
         enddo
         do j=1, max0(nk_lcase, nk)
            if (a4 == Species_lcase(j)) then
                model(WhichModel)%specie(i,1) = j * nzConst
                model(WhichModel)%atoms(4,i,1)= no(j)
                sumOcc(j) = sumOcc(j) + nsymTot * TotOcc
*gl*            sincronizza = 0
                exit
            endif
         enddo

  222    continue


         if (ifCartesian == 1) then
             ortop = orthomatrixi_std(cell(1:6))
             x1(1:3) = model(WhichModel)%atoms(1:3,i,1)
             call MoltMatVec(ortop, x1, x2)
             model(WhichModel)%atoms(1:3,i,1) = x2(1:3)
         endif
         x1(1:3) = model(WhichModel)%atoms(1:3,i,1)
         call MoltMatVec(rm, x1, x2)
         model(WhichModel)%ortho(1:3,i,1) = x2(1:3)
         if (iprint > 0) then
             write(6,11) i, aLab(i), a4,
     *                   model(WhichModel)%atoms(1:5,i,1),
     *                   IsoAniso(i),
     *                   model(WhichModel)%th_fact(i,1)
         endif
      enddo
!
!-- compute the correct cell content taking into account 
!-- the sum of occupancies
!
      if (inMemoryOnly == 0) then
          cif_number(1:nk) = 0
          do i=1, nats
             j = model(WhichModel)%specie(i,1) / nzConst
             if (j > 0) then
                 occ = model(WhichModel)%atoms(5,i,1)
                 cif_number(j) = cif_number(j) + occ
             endif
          enddo
          nw(1:nk) = nint( totop * cif_number(1:nk) )
          call CreaAtmPropInfo(WhichProps, ier)
          call GetFromAtmStruct
      endif
!
      if (n_aniso > 0) then
         do n_a=1, n_aniso
            read(jgrap) Label, cif_bij(1:6)
            j = 0
            do i=1, nats
               if (Label == model(WhichModel)%Label(i)) then
                   j = i
                   exit
               endif
            enddo
            if (j == 0) then
                call CheckAniso(Label, Species_lcase, nk_lcase, 
     *                          nats, j, ier)
            endif
            if (ier == -1) then
                exit
            else
                IsoAniso(j) = 1
            endif

            if (iprint > 0) then
                write(6,12) j, aLab(j), b_or_u, cif_bij(1:6)
            endif
   11 format(i5,1h),2x,a,2x,a,5f8.3,i3,f8.3)
   12 format(i5,1h],2x,a,i4,6f8.3)
!--non vedo la trasformazione del u(iso) in b(iso) ?????
            if (b_or_u == 1) then
                model(WhichModel)%bij(1:6,j,1) = cif_bij(1:6)
            else
c--
!-----------------------------------------------------------
!  SHELX:
!                        (1)(2)(3)(4)(5)(6)       
!  la sequenza in shelx: 11 22 33 23 13 12
!  la sequenza in sir  : 11 12 13 22 23 33
!  quindi: b(1) = UijToBij_11*u(1)
!          b(4) = UijToBij_22*u(2)
!          b(6) = UijToBij_33*u(3)
!          b(5) = UijToBij_23*u(4)
!          b(3) = UijToBij_13*u(5)
!          b(2) = UijToBij_12*u(6)
!-----------------------------------------------------------
!--in list 5 sono memorizzati come:
!  bij(11)  bij(12)  bij(13)  bij(22)  bij(23)  bij(33)
                model(WhichModel)%bij(1,j,1)=cif_bij(1)*UijToBij_11
                model(WhichModel)%bij(2,j,1)=cif_bij(6)*UijToBij_12
                model(WhichModel)%bij(3,j,1)=cif_bij(5)*UijToBij_13
                model(WhichModel)%bij(4,j,1)=cif_bij(2)*UijToBij_22
                model(WhichModel)%bij(5,j,1)=cif_bij(4)*UijToBij_23
                model(WhichModel)%bij(6,j,1)=cif_bij(3)*UijToBij_33
            endif
         enddo
      endif
!
      natsInModel(WhichModel) = nats
      close(jgrap)
!
!??       Species_lcase(:) = Species(:)
!??       Species(:) = vSpecie(:)
!??       vSpecie(:) = Species_lcase(:)

          if (nk_lcase == 0) sincronizza = 0
          if (sincronizza == 1) then
              vSpecie(:) = SpeciesTmp(:)
              if (inMemoryOnly == 0) then
                  Species(:) = Species_lcase(:)
              endif
              call SincronizzaSpecieRemo()
          endif
!
      if (ier == 0) then
          if (aLab(1)(1:2) == 'XX') then
              iniz = 1
              ifin = nats
              call MakeLab(iniz,ifin)
          endif
          if (bfacMR > 0) then
              model(WhichModel)%th_fact(1:nats,1) = bfacMR
          endif
          if (inMemoryOnly == 0) then
!??!          call frm05
          endif
      endif
!
      sumOcc(:) = 0.0
      do i=1, nats
         k = iabs(model(WhichModel)%specie(i,1))
         if (k >= nzConst) then
             k = k / nzConst
         endif
         TotOcc = model(WhichModel)%atoms(5,i,1)
         if (k > 0) then
             model(WhichModel)%atoms(4,i,1)= no(k)
             sumOcc(k) = sumOcc(k) + nsymTot * TotOcc
         else
             model(WhichModel)%atoms(4,i,1)= 1
         endif
      enddo
!
      do i=1,nk
         if (nw(i) /= nint(sumOcc(i))) then
             nw(:) = nint(sumOcc(:))
             exit
         endif
      enddo
!
!
      if (inMemoryOnly == 0 .and. neutro == 0) then
          call WriteCellInfo
          call WriteSymmInfo(lo)
      endif
!
      if (InfoOK(6) == 0 .and. ifRefl == 1) then
          close(jfile)
      else
          close(jfile, status = 'delete')
      endif
!
      WhichProps = 0
      call GetFromAtmStruct
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CheckAniso(Label, Species_lcase, nk_lcase,
     *                      nats, j, ier)
      USE General
      USE RemoModule
!
      implicit none
      integer :: j, ier, i, k, nk_lcase, nats
      character (len= 4) :: a4, Species_lcase(18)
      character (len=16) :: Label
!
      do i=1, nats
         a4 = model(WhichModel)%Label(i)(1:4)
         call lcase(a4)
         do k=1, max0(nk_lcase, nk)
            if (a4 == Species_lcase(k)) then
                j = i
                exit
            endif
         enddo
      enddo
      if (j == 0) then
          ier = -1
          Msg = 'Error in _atom_site_aniso_label' // ' ' // Label
          call MsgWinErr('WARNING', Msg, WARN_WINDOW, i)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PreCheckIons(ifMsg)
      USE General
!
      character*4 ions(2,18)
!
      do i=1, nk
         write(Species(i),'(a4)') nalf(i)
      enddo
      call CheckIons(ifMsg,ions)
      do i=1, nk
         read(ions(2,i),'(a4)') nalf(i)
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CheckIons(ifMsg, ions)
      USE General
!
      character*4 ions(2,18),ion1,ion2
!
      ifIons = 0
      do j=1, nk
         ions(1,j) = Species(j)
         call lcase(ions(1,j))
         if (index(ions(1,j),'-') > 0 .or. 
     *       index(ions(1,j),'+') > 0) then
             ifIons = 1
         endif
         ions(2,j) = ions(1,j)
      enddo
      if (ifIons == 0) then
          return
      endif
      jtype = 2
      jform = 1
      ier1 = jopen(kform, ffile, jtype, jform, ierr)
!
      do j=1, nk
         ifFound = 0
         rewind kform
         read(kform,'(a)') Inte       ! header
         read(kform,'(i5)') nlines    ! number of lines per specie
         do
            read(kform,'(a)',end=100) Inte   ! first line of the specie
            if (Inte(1:1) /= '#') then
                if (Inte(1:4) == ions(1,j)) then
                    ifFound = 1
                    exit
                endif
            endif
            do i=1, nlines-1
               read(kform,'(a)',end=100) Inte
            enddo
         enddo
  100    if (ifFound == 0) then
!
!-- may be it is an ion (not included in xen file)
!
             if (index(ions(1,j),'-') > 0 .or. 
     *           index(ions(1,j),'+') > 0) then
                 k = Lung(ions(1,j))
                 ions(2,j)(k-1:k) = '  '
                 if (ifMsg == 1) then
                     ion1 = ions(1,j)
                     ion2 = ions(2,j)
                     call ucase(ion1(1:1))
                     call ucase(ion2(1:1))
                     Msg = 'Ion ' // ion1 // ' changed in ' // ion2
                     call MsgWinErr('WARNING', Msg, WARN_WINDOW,
     *                              nExitCode)
                 endif
             endif
         endif
      enddo
!
      close(kform)
!
      do j=1, nk
         Species(j) = ions(2,j)
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SincronizzaCIFNew(ier)
      USE General
      USE Atomi
      USE Molcom
      USE RemoModule
      USE Properties
!
      integer puntatore(18)
!
      nkk = max0(AtmProperties(WhichProps)%nSpecies, nk)
      do i=1, nkk
         call lcase(Species(i))
         call lcase(vSpecie(i))
      enddo
      do i=1, nkk
         do j=1, nkk
            if (Species(i) == vSpecie(j)) then
                puntatore(i) = j
                exit
            endif
         enddo
      enddo
      do i=1, natsInModel(WhichModel)
         iabsnz = iabs(model(WhichModel)%specie(i,1))
         kk = mod(model(WhichModel)%specie(i,1), nzConst)
         lnz = iabsnz / nzConst
         lnz = puntatore(lnz)
         model(WhichModel)%specie(i,1) = lnz * nzConst + kk
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      function kQualeFormato(filet)
      character*(*) filet
      character*3 est
!
      k = Lung(filet)
      est = filet(k-2:k)
      call lcase(est)
      if (est == 'ins' .or. est == 'res') then
          kQualeFormato = 1                    ! formato SHELX
      elseif (est == 'pdb' .or. est == 'ent') then
          kQualeFormato = 2                    ! formato PDB
*      elseif (est == 'li5') then
*          kQualeFormato = 3                    ! formato CAOS
      elseif (est == 'cif') then
          kQualeFormato = 4                    ! formato CIF
      else
          kQualeFormato = 0                    ! formato SIR
      endif
!
      return
      end
!-----------------------------------------------------------------------
