void apri_GLwindow(GtkWidget *item, gpointer data);
gboolean ifMenubar = TRUE;


static mr_action_entry Menu_Items[] = {

{0, 1, "File", "_File", "File Operations", NULL, NULL, NULL, 1, 1}, 
{1, 1, "New", "_New", "Create a new Project", "filenew", G_CALLBACK(open_newproj_dlg), NULL, -1, 1}, 
{1, 1, "Load & Go", "_Load & Go", "Load input (.sir) file and start the run", "opensir", G_CALLBACK(open_file), NULL, 0, 1}, 
{1, 1, "Old Project", "_Old Project", "Load Project (.bin) file", "openbin", G_CALLBACK(open_file), NULL, 1, 1}, 
{1, 1, "Recent Projects", "_Recent Projects", "Load 1 of 5 projects", "void", NULL, NULL, -1, 1}, 
{2, 1, "recent1", "recent1", "Load this project", NULL, NULL, NULL, -1, 1}, 
{2, 1, "recent2", "recent2", "Load this project", NULL, NULL, NULL, -1, 1}, 
{2, 1, "recent3", "recent3", "Load this project", NULL, NULL, NULL, -1, 1}, 
{2, 1, "recent4", "recent4", "Load this project", NULL, NULL, NULL, -1, 1}, 
{2, 1, "recent5", "recent5", "Load this project", NULL, NULL, NULL, -1, 1}, 
{1, 4},
{1, 1, "Load Examples", "Load Ex_amples", "Load Example (.sir) file and start the run", "opensir", G_CALLBACK(open_file), NULL, 101, 1}, 
{1, 4},
{1, 1, "Import", "_Import", "Import file", "importb", NULL, NULL, -1, 1}, 
{2, 1, "Sir Fragment(fra)", "_Sir Fragment(*.fra)", "Sir Fragment", NULL, G_CALLBACK(open_file), NULL, 4, 1}, 
{2, 1, "Caos File(fil)", "_Caos File(*.fil)", "Caos File", NULL, G_CALLBACK(open_file), NULL, 5, 1}, 
{2, 1, "Shelx File (ins)", "S_helx File (*.ins,*.res)", "Shelx File", NULL, G_CALLBACK(open_file), NULL, 6, 1}, 
{2, 1, "PDB (pdb,ent)", "_PDB (*.pdb,*.ent)", "PDB Fragment", NULL, G_CALLBACK(open_file), NULL, 7, 1}, 
{2, 1, "C.I.F. (*.cif)", "C.I.F. (*.cif)", "C.I.F format", NULL, G_CALLBACK(open_file), NULL, 13, 1}, 
{2, 1, "Z-matrix ", "Z-matrix ", "Z-matrix format", NULL, NULL, NULL, -1, 1}, 
{3, 1, "Z-matrix cordinates (*.fhz) in Fenske-Hall standard", "Z-matrix cordinates (*.fhz) in Fenske-Hall standard", "Z-matrix format", NULL, G_CALLBACK(open_file), NULL, 14, 1}, 
{3, 1, "Z-matrix, format (*.mop)", "Z-matrix, format (*.mop)", "Z-matrix mop format ", NULL, G_CALLBACK(open_file), NULL, 15, 1}, 
{1, 1, "Export", "_Export", "File Export", "exportb", NULL, NULL, -1, 0}, 
{2, 1, "Shelx (res)", "_Shelx (*.res)", "Shelx", NULL, G_CALLBACK(c_esporta), NULL, 1, 1}, 
{2, 1, "Crystals (cry)", "_Crystals (*.cry)", "Crystals", NULL, G_CALLBACK(c_esporta), NULL, 2, 1}, 
{2, 1, "Xtal (phs, map)", "_Xtal (*.phs, *.map)", "Xtal", NULL, G_CALLBACK(c_esporta), NULL, 3, 1}, 
{2, 1, "CCP4 (map)", "CCP_4 (*.map)", "CCP_4", NULL, G_CALLBACK(c_esporta), NULL, 4, 1}, 
{2, 1, "PDB (pdb)", "_PDB (*.pdb)", "PDB", NULL, G_CALLBACK(c_esporta), NULL, 5, 1}, 
{2, 1, "Caos (fil)", "C_aos (*.fil)", "Caos", NULL, G_CALLBACK(c_esporta), NULL, 6, 1}, 
{2, 1, "Postscript (ps)", "P_ostscript (*.ps)", "PostScript", NULL, G_CALLBACK(c_esporta), NULL, 7, 1}, 
{2, 1, "Schakal (sch)", "Sc_hakal (*.sch)", "Schakal", NULL, G_CALLBACK(c_esporta), NULL, 9, 1}, 
{2, 1, "Moldraw (mol)", "_Moldraw (*.mol)", "Moldraw", NULL, G_CALLBACK(c_esporta), NULL, 10, 1}, 
{2, 1, "XYZ format (xyz)", "_XYZ format (*.xyz)", "XYZ format", NULL, G_CALLBACK(c_esporta), NULL, 11, 1}, 
{2, 1, "PovRay format (pov)", "Pov_Ray format (*.pov)", "PovRay format", NULL, G_CALLBACK(c_esporta), NULL, 12, 1}, 
{2, 1, "C.I.F. format (*.cif)", "C.I.F. format (*.cif)", "C.I.F. format", NULL, G_CALLBACK(c_esporta), NULL, 13, 1}, 
{2, 1, "Z-matrix format (*.fhz)", "Z-matrix format (*.fhz)", "Z-matrix format", NULL, G_CALLBACK(c_esporta), NULL, 14, 1}, 
{1, 4},
//{1, 1, "Save", "_Save", "Save model or project file", "save", G_CALLBACK(c_savebinfile), NULL, -1, 0}, 
{1, 1, "Save", "_Save", "Save project file", "save", G_CALLBACK(c_savebinfile), NULL, -1, 0}, 
{1, 1, "Restore", "Res_tore", "Restore project file", "restore", G_CALLBACK(c_restorebinfile), NULL, -1, 1}, 
{1, 4},
{1, 1, "View output file", "_View output file", "View output file", "output", G_CALLBACK(c_browserv2), NULL, 5, 1}, 
{1, 1, "Summary", "S_ummary", "Summary of results", "summary", G_CALLBACK(c_browserv2), NULL, 1, 0}, 
//{1, 1, "Supplementary", "Su_pplementary", "Supplementary Info", "contents", G_CALLBACK(c_supplementary), NULL, 1, 0}, 
{1, 4},
{1, 1, "HardCopy", "_HardCopy", "Hard Copy", "camera", G_CALLBACK(PrintScreen), NULL, 1, 1}, 
{1, 4},
{1, 1, "Exit", "E_xit", "Exit " MR_PACKAGE, "quit", G_CALLBACK(exit_confirm), NULL, -1, 1}, 
#if 0
{0, 1, "Modify", "_Modify", "Modify", NULL, NULL, NULL, -1, 0}, 
{1, 1, "Model", "_Model", "Modify Model", "modify_model", NULL, NULL, -1, 1}, 
//{2, 1, "Select", "_Select", "Select part of the model", "sel_ico", NULL, NULL, -1, 1}, 
//{3, 1, "To delete", "To _delete", "Delete selected atoms", "selectdel", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Select to delete", "Select to _delete", "Delete selected atoms", "selectdel", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Delete Atoms", "_Delete Atoms", "Delete selected atom(s)", "delete", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Undelete", "_Undelete", "Undelete atoms", "undo", G_CALLBACK(c_undelete), NULL, -1, 1}, 
{2, 1, "ReName", "Re_Name", "Rename", "rename_ico", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Change species", "C_hange species", "Change atomic species", "relabel", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "ReNumber", "Re_Number", "Renumber", "renumber", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Sort by Species", "_Sort by Species", "Sort by Species", "sort", G_CALLBACK(c_sortbylabel), NULL, -1, 1}, 
{2, 1, "Add Bonds", "_Add Bonds", "Add Bonds", "bondon", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Del Bonds", "Del _Bonds", "Delete Bonds", "bondoff", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Move Atoms", "_Move Atoms", "Move Atoms", "moveatoms", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "ReGroup", "Re_Group", "Regroup Atoms", "regroup", G_CALLBACK(c_regroup), NULL, -1, 1}, 
{2, 4},
{2, 1, "Complete", "_Complete", "Complete 6-membered ring", "complete", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Regularize", "_Regularize", "Regularize 6-membered ring", "regularize", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Tetrahedron", "_Tetrahedron", "Complete Tetrahedron", "tetrahedron", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Octahedron", "_Octahedron", "Complete Octahedron", "ballpoloff", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Add Atom", "Add At_om", "Add one Atom", "add1atom", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Site", "_Site", "Modify site", "occupancy", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{1, 1, "Bond distance", "_Bond distance", "Modify bond distances", "bonddist", G_CALLBACK(set_bd), NULL, -1, 1}, 
{1, 1, "Enant", "_Enant.", "Change Enantiomorph", "enan", G_CALLBACK(c_enant), NULL, -1, 1}, 
{1, 1, "Transform Model", "T_ransform Model", "Transform Model", "transform", G_CALLBACK(TransformModel), NULL, -1, 1}, 
{1, 1, "Cell Content", "_Cell Content", "Modify Cell Content", "cellcontent_ico", G_CALLBACK(open_cellc), NULL, -1, 1}, 
#endif
{0, 1, "Settings", "_Settings", "Settings", NULL, NULL, NULL, -1, 1}, 
{1, 1, "Fonts & Colors", "_Fonts & Colors", "Select drawing colors and fonts", "font_ico", G_CALLBACK(open_fcolors), NULL, -1, 1}, 
{1, 1, "Alien Programs", "_Alien Programs", "Set path for alien programs", "alien", G_CALLBACK(open_alien), NULL, -1, 1}, 
{1, 4},
#if 0
{1, 1, "Drawing Options", "Drawing _Options", "Select drawing options", "draw_ico", G_CALLBACK(open_optdlg), NULL, 1, 0}, 
{1, 1, "Hydrogen Bond", "_Hydrogen Bond", "Hydrogen bonds", "hbond", NULL, NULL, -1, 0}, 
{2, 1, "Add Hydrogen Bonds", "_Add Hydrogen Bonds", "Add Hydrogen bonds", NULL, G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Delete Hydrogen Bonds", "_Delete Hydrogen Bonds", "Delete Hydrogen bonds", NULL, G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Reset Hydrogen Bonds", "_Reset Hydrogen Bonds", "Reset Hydrogen bonds", NULL, G_CALLBACK(c_reset_hbonds), NULL, 1, 1}, 
#endif
{1, -1, "Build", "_Build", "Build", "build", NULL, NULL, -1, 0}, 
{2, 1, "Automatic", "_Automatic", "Automatic", NULL, G_CALLBACK(c_autobuild), NULL, -1, 1}, 
{2, 1, "Aided", "A_ided", "Aided building", NULL, G_CALLBACK(aided_build), NULL, -1, 1}, 
#if 0
{2, 1, "Reset", "_Reset", "Reset to asymmetric unit", NULL, G_CALLBACK(c_resetbuild), NULL, -1, 1}, 
#endif
{1, 1, "Plot Style", "Plot _Style", "Change the plot style of selected atoms", "plot_ico", G_CALLBACK(open_cplotstyle_dlg), NULL, -1, 0}, 
{0, 1, "ViewMenu", "_View", "View using Jav", NULL, NULL, NULL, -1, 0}, 
#if 0
{1, 1, "Select", "_Select", "Select part of the model", "sel_ico", NULL, NULL, -1, 1}, 
//{2, -1, "To delete", "To _delete", "Delete selected atoms", "selectdel", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "To hide", "To _hide", "Hide selected atoms", "selecthide", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "To display", "To d_isplay", "Display only selected atoms", "selectshow", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Show all", "Show _all", "Show all atoms", "showall", G_CALLBACK(c_show_all), NULL, -1, 1}, 
{2, 1, "To change color", "To _change color", "Change the color of selected atoms", "selectcol", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{1, 1, "Hide-Show Species", "_Hide/Show Species", "Hide/Show species", "showhide", G_CALLBACK(HideShowSpecies), NULL, -1, 1}, 
{1, 4},
{1, 1, "RotateMenu", "_Rotate", "Rotate the model", "rotate", G_CALLBACK(mostra_tbdamenu), NULL, -1, 1}, 
{1, 1, "TranslateMenu", "_Translate", "Translate the model", "translate", G_CALLBACK(mostra_tbdamenu), NULL, -1, 1}, 
{1, 4},
{1, 1, "Zoom In", "Zoom _In", "Zoom In", "zoom_in", G_CALLBACK(view_options), NULL, 15, 1}, 
{1, 1, "Zoom Out", "Zoom _Out", "Zoom Out", "zoom_out", G_CALLBACK(view_options), NULL, 16, 1}, 
{1, 4},
{1, 1, "Reset View", "Reset _View", "Reset the view", "reset", G_CALLBACK(view_options), NULL, 17, 1}, 
{1, 4},
{1, 1, "View Plane", "View _Plane", "Select View Plane", "viewplane", NULL, NULL, -1, 1}, 
{2, 1, "Least Squares P", "_Least Squares P.", "Least Squares Plane ", "least", G_CALLBACK(view_options), NULL, 18, 1}, 
{2, 1, "Norm to L& M", "_Norm. to L.& M.", "Normal to Least Squares Plane ", "void", G_CALLBACK(view_options), NULL, 19, 1}, 
{2, 1, "Most Squares P", "_Most Squares P.", "Most Squares Plane ", "void", G_CALLBACK(view_options), NULL, 20, 1}, 
{2, 1, "Normal to a", "Normal to _a", "Plane Normal to a", "alonga", G_CALLBACK(view_options), NULL, 21, 1}, 
{2, 1, "Normal to b", "Normal to _b", "Plane Normal to b", "alongb", G_CALLBACK(view_options), NULL, 22, 1}, 
{2, 1, "Normal to c", "Normal to _c", "Plane Normal to c", "alongc", G_CALLBACK(view_options), NULL, 23, 1}, 
{2, 1, "3-atoms Plane", "_3-atoms Plane", "User-defined Plane ", "void", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{1, 4},
#endif
{1, 1, "Jav", "Jav", "Open structure in Jav", "jav", G_CALLBACK(call_javs), NULL, -1, 1}, 
{0, 1, "Solve", "Solve", "Final Stage Procedures", NULL, NULL, NULL, -1, 0}, 
//{1, 1, "Automatic atomic model", "_Automatic atomic model", "Peak search and automatic Least Squares", "automatic_lsq", G_CALLBACK(c_restart), NULL, 1, 1}, 
{1, 1, "MapViewer", "_MapViewer", "3D contour via Jav", "contour", G_CALLBACK(c_restart), NULL, 3, 1}, 
{1, 1, "Contour", "_Contour", "2D contour", "2D_contour", G_CALLBACK(c_restart), NULL, 4, 1}, 
{1, 1, "Select among the best R% trials", "_Select among the best R% trials", "Recover a model among those with the best R% value", "best_trial", G_CALLBACK(c_best_r), NULL, -1, 1}, 
{1, 1, "Re-compute trial", "R_e-compute trial", "Re-compute atomic model using a previous trial.", "re-compute", G_CALLBACK(c_restart), NULL, 5, 1}, 
{1, 1, "Develop new trials", "_Develop new trials", " Develop new trials", "new_trials", G_CALLBACK(tune), NULL, -1, 1}, 
{1, 1, "Simulated Annealing", "_Simulated Annealing", " Start Simulated Annealing procedure", "sa", G_CALLBACK(c_globalopt), NULL, 0, 1}, 
{0, 1, "Refine", "_Refine", "Refine the structure", NULL, NULL, NULL, -1, 0}, 
{1, 1, "LSQ", "_LSQ", "Least Squares Refinement", "lsq1_ico", G_CALLBACK(c_lsq), NULL, -1, 1}, 
{1, 1, "LSQ info", "L_SQ info", "LSQ info", "lsqinfo_ico", G_CALLBACK(c_browserv2), NULL, 4, 1}, 
#if 0
{1, 1, "Restraints", "_Restraints", "Manage restraints", "restr_ico", G_CALLBACK(restraints), NULL, -1, 1}, 
{1, 1, "DLSQ", "_DLSQ", "Manage DLSQ", "dlsq_ico", G_CALLBACK(open_dlsq), NULL, -1, 1}, 
{1, 1, "Groups", "_Groups", "Groups", "groups", NULL, NULL, -1, 0}, 
{2, 1, "Rigid Body", "Rigid _Body", "Rigid Body", "rigidbody", G_CALLBACK(RigidBody), NULL, -1, 1}, 
{2, 1, "Group Manager", "_Group Manager", "Group Manager", "groupmgr", G_CALLBACK(open_groupmgr), NULL, -1, 1}, 
#endif
{1, 1, "Thermal Factor", "T_hermal Factor", "Delete atoms with a very high thermal factor", "thf_ani2.gif", G_CALLBACK(c_ThFacTooBig), NULL, -1, 1}, 
{1, 1, "Fourier", "_Fourier", "Fourier synthesis", "fourier_ico", G_CALLBACK(open_fourier_dlg), NULL, -1, 1}, 
#if 0
{1, 1, "Hydrogens", "H_ydrogens", "Manage Hydrogens", "hydro_ico", NULL, NULL, -1, 0}, 
{2, 1, "HAutomatic", "A_utomatic", "Hydrogens automatic generation", "automatic_ico", G_CALLBACK(c_autohydro), NULL, -1, 1}, 
{2, 1, "Wizard", "_Wizard", "Hydrogens aided generation", "wizard_ico", G_CALLBACK(whydro), NULL, -1, 1}, 
{2, 1, "Single", "_Single", "Add single hydrogen", "single_ico", G_CALLBACK(singlehydro), NULL, -1, 1}, 
{2, 1, "Delete", "_Delete", "Delete all hydrogens", "close", G_CALLBACK(delete_hydro), NULL, -1, 1}, 
{1, 1, "Agreement", "A_greement", "Agreement information", "agreement_ico", G_CALLBACK(open_agreement_dialog), NULL, -1, 0}, 
#endif
{1, 1, "Compare Atoms", "C_ompare Atoms", "Compare coords", "compare", G_CALLBACK(compare_atoms), NULL, -1, 0}, 
#if 0
{0, 1, "InfoMenu", "_Info", "Informations on the structure", NULL, NULL, NULL, -1, 0}, 
{1, 1, "GeometryMenu", "_Geometry", "Distances and Angles calculation", "geometry", NULL, NULL, -1, 1}, 
{2, 1, "Distances", "_Distances", "Two atoms distance", "distances", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Sphere", "_Sphere", "Distances around one atom", "dist_sfe", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Short Distances", "S_hort Distances", "Short distances table", "short_d", G_CALLBACK(c_browserv2), NULL, 8, 1}, 
{2, 1, "Long Distances", "_Long Distances", "Long distances table", "long_d", G_CALLBACK(c_browserv2), NULL, 9, 1}, 
{2, 1, "Angles", "_Angles", "Angles", "angles", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Torsion Angles", "_Torsion Angles", "Torsion Angles", "tangles", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{2, 1, "Geometric Calculations", "_Geometric Calculations", "Geometric Calculations", "geomc_ico", G_CALLBACK(open_geocalc), NULL, -1, 1}, 
{1, 4},
{1, 1, "Atoms Table", "_Atoms Table", "Atoms Table", "numtab", G_CALLBACK(c_browserv2), NULL, 3, 1}, 
{1, 1, "Tables", "_Tables", "Publication Tables", "tables_ico", G_CALLBACK(open_tables), NULL, -1, 1}, 
{1, 1, "Bar Chart", "_Bar Chart", "Intensities bar chart", "barchart", G_CALLBACK(c_histograms), NULL, -1, 1}, 
{1, 1, "Find", "_Find", "Find atoms", "find", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{1, 1, "Who", "_Who", "Info on selected atoms", "who", G_CALLBACK(mostra_tbg1), NULL, -1, 1}, 
{1, 1, "Output", "_Output", "View output file", "output", G_CALLBACK(c_browserv2), NULL, 5, 1}, 
{1, 1, "Summary", "_Summary", "Summary of results", "summary", G_CALLBACK(c_browserv2), NULL, 1, 1}, 
{1, -1, "Map Variance", "_Map Variance", "Map Variance", "mapvariance", G_CALLBACK(map_variance), NULL, 1, 1}, 
//{1, 1, "Supplementary", "_Supplementary", "Supplementary Info", "contents", G_CALLBACK(c_supplementary), NULL, 1, 1}, 
//{1, 1, "FOMs Histograms", "F_OMs Histograms", "Trials FOMs graphics", "histogram", G_CALLBACK(c_doallgraphs), NULL, -1, 1}, 
#endif
{0, 1, "Help", "_Help", "Help", NULL, NULL, NULL, -1, 1}, 
{1, 1, "Check for Updates", "Check for _Updates", "Check for updates", "checkforupdate", G_CALLBACK(CheckForUpdates), NULL, -1, 1}, 
{1, 1, "Content", "_Content", "Help on Content", "help_content", G_CALLBACK(system_browser), NULL, -1, 1}, 
{1, 1, "Keyboard", "_Keyboard", "Help on Keyboard", "keyb_ico", G_CALLBACK(open_khelp_sir), NULL, -1, 1}, 
{1, 1, "About", "_About", "About " MR_PACKAGE, "info_about", G_CALLBACK(open_about_sir), NULL, -1, 1},
};

static guint n_menu_items = G_N_ELEMENTS (Menu_Items);

static gpointer menuitems = (gpointer) Menu_Items;

#ifdef USE_ACTIONS
static const gchar *menu_info =
"<ui>"
"  <menubar name='MenuBar'>"
"    <menu action='File'>"
"      <menuitem action='New'/>"
"      <menuitem action='Load &amp; Go'/>"
"      <menuitem action='Old Project'/>"
"      <menu action='Recent Projects'>"
"         <menuitem action='recent1'/>"
"         <menuitem action='recent2'/>"
"         <menuitem action='recent3'/>"
"         <menuitem action='recent4'/>"
"         <menuitem action='recent5'/>"
"      </menu>"
"      <separator/>"
"      <menuitem action='Load Examples'/>"
"      <menu action='Import'>"
"         <menuitem action='Sir Fragment(fra)'/>"
"         <menuitem action='Caos File(fil)'/>"
"         <menuitem action='Shelx File (ins)'/>"
"         <menuitem action='PDB (pdb,ent)'/>"
"         <menuitem action='C.I.F. (*.cif)'/>"
"         <menu  action='Z-matrix '>"
"           <menuitem action='Z-matrix cordinates (*.fhz) in Fenske-Hall standard'/>"
"           <menuitem action='Z-matrix, format (*.mop)'/>"
"         </menu>"
"      </menu>"
"      <menu action='Export'>"
"         <menuitem action='Shelx (res)'/>"
"         <menuitem action='Crystals (cry)'/>"
"         <menuitem action='Xtal (phs, map)'/>"
"         <menuitem action='CCP4 (map)'/>"
"         <menuitem action='PDB (pdb)'/>"
"         <menuitem action='Caos (fil)'/>"
"         <menuitem action='Postscript (ps)'/>"
"         <menuitem action='Schakal (sch)'/>"
"         <menuitem action='Moldraw (mol)'/>"
"         <menuitem action='XYZ format (xyz)'/>"
"         <menuitem action='PovRay format (pov)'/>"
"         <menuitem action='C.I.F. format (*.cif)'/>"
"         <menuitem action='Z-matrix format (*.fhz)'/>"
"      </menu>"
"      <separator/>"
"      <menuitem action='Save'/>"
"      <menuitem action='Restore'/>"
"      <separator/>"
"      <menuitem action='View output file'/>"
"      <menuitem action='Summary'/>"
//"      <menuitem action='Supplementary'/>"
"      <separator/>"
"      <menuitem action='HardCopy'/>"
"      <separator/>"
"      <menuitem action='Exit'/>"
"    </menu>"
#if 0
"    <menu action='Modify'>"
"      <menu action='Model'>"
"        <menuitem action='Select to delete'/>"
"        <menuitem action='Delete Atoms'/>"
"        <menuitem action='Undelete'/>"
"        <menuitem action='ReName'/>"
"        <menuitem action='Change species'/>"
"        <menuitem action='ReNumber'/>"
"        <menuitem action='Sort by Species'/>"
"        <menuitem action='Add Bonds'/>"
"        <menuitem action='Del Bonds'/>"
"        <menuitem action='Move Atoms'/>"
"        <menuitem action='ReGroup'/>"
"        <separator/>"
"        <menuitem action='Complete'/>"
"        <menuitem action='Regularize'/>"
"        <menuitem action='Tetrahedron'/>"
"        <menuitem action='Octahedron'/>"
"        <menuitem action='Add Atom'/>"
"        <menuitem action='Site'/>"
"        <menuitem action='Site'/>"
"      </menu>"
"      <menuitem action='Bond distance'/>"
"      <menuitem action='Enant'/>"
"      <menuitem action='Transform Model'/>"
"      <menuitem action='Cell Content'/>"
"    </menu>"
#endif
"    <menu action='Settings'>"
"      <menuitem action='Fonts &amp; Colors'/>"
"      <menuitem action='Alien Programs'/>"
"      <separator/>"
#if 0
"      <menuitem action='Drawing Options'/>"
"      <menu  action='Hydrogen Bond'>"
"         <menuitem action='Add Hydrogen Bonds'/>"
"         <menuitem action='Delete Hydrogen Bonds'/>"
"         <menuitem action='Reset Hydrogen Bonds'/>"
"      </menu>"
#endif
"      <menu  action='Build'>"
"         <menuitem action='Automatic'/>"
"         <menuitem action='Aided'/>"
#if 0
"         <menuitem action='Reset'/>"
"         <menuitem action='Delete Hydrogen Bonds'/>"
#endif
"      </menu>"
"      <menuitem action='Plot Style'/>"
"    </menu>"
"    <menu action='ViewMenu'>"
#if 0
"      <menu  action='Select'>"
"         <menuitem action='To hide'/>"
"         <menuitem action='To display'/>"
"         <menuitem action='Show all'/>"
"         <menuitem action='To change color'/>"
"      </menu>"
"      <menuitem action='Hide-Show Species'/>"
"      <separator/>"
"      <menuitem action='RotateMenu'/>"
"      <menuitem action='TranslateMenu'/>"
"      <separator/>"
"      <menuitem action='Zoom In'/>"
"      <menuitem action='Zoom Out'/>"
"      <separator/>"
"      <menuitem action='Reset View'/>"
"      <separator/>"
"      <menu  action='View Plane'>"
"         <menuitem action='Least Squares P'/>"
"         <menuitem action='Norm to L&amp; M'/>"
"         <menuitem action='Most Squares P'/>"
"         <menuitem action='Normal to a'/>"
"         <menuitem action='Normal to b'/>"
"         <menuitem action='Normal to c'/>"
"         <menuitem action='3-atoms Plane'/>"
"      </menu>"
"      <separator/>"
#endif
"      <menuitem action='Jav'/>"
"    </menu>"
"    <menu action='Solve'>"
//"      <menuitem action='Automatic atomic model'/>"
"      <menuitem action='MapViewer'/>"
"      <menuitem action='Contour'/>"
"      <menuitem action='Select among the best R% trials'/>"
"      <menuitem action='Re-compute trial'/>"
"      <menuitem action='Develop new trials'/>"
"      <menuitem action='Simulated Annealing'/>"
"    </menu>"
"    <menu action='Refine'>"
"      <menuitem action='LSQ'/>"
"      <menuitem action='LSQ info'/>"
#if 0
"      <menuitem action='Restraints'/>"
"      <menuitem action='DLSQ'/>"
"      <menu  action='Groups'>"
"        <menuitem action='Rigid Body'/>"
"        <menuitem action='Group Manager'/>"
"      </menu>"
#endif
"      <menuitem action='Thermal Factor'/>"
"      <menuitem action='Fourier'/>"
#if 0
"      <menu  action='Hydrogens'>"
"        <menuitem action='HAutomatic'/>"
"        <menuitem action='Wizard'/>"
"        <menuitem action='Single'/>"
"        <menuitem action='Delete'/>"
"      </menu>"
"      <menuitem action='Agreement'/>"
#endif
"      <menuitem action='Compare Atoms'/>"
"    </menu>"
#if 0
"    <menu action='InfoMenu'>"
"      <menu  action='GeometryMenu'>"
"        <menuitem action='Distances'/>"
"        <menuitem action='Sphere'/>"
"        <menuitem action='Short Distances'/>"
"        <menuitem action='Long Distances'/>"
"        <menuitem action='Angles'/>"
"        <menuitem action='Torsion Angles'/>"
"        <menuitem action='Geometric Calculations'/>"
"      </menu>"
"      <separator/>"
"      <menuitem action='Atoms Table'/>"
"      <menuitem action='Tables'/>"
"      <menuitem action='Bar Chart'/>"
"      <menuitem action='Find'/>"
"      <menuitem action='Who'/>"
"      <menuitem action='Output'/>"
"      <menuitem action='Summary'/>"
"      <menuitem action='Map Variance'/>"
//"      <menuitem action='Supplementary'/>"
//"      <menuitem action='FOMs Histograms'/>"
"    </menu>"
#endif
"    <menu action='Help'>"
"      <menuitem action='Check for Updates'/>"
"      <menuitem action='Content'/>"
"      <menuitem action='Keyboard'/>"
"      <menuitem action='About'/>"
"    </menu>"
"  </menubar>"
"</ui>";
#endif
