#include <utils.h>
#include <gtkdefs.h>
#include <sir_application.h>
#include "gtkmrnew.h"
#include <int_main.h>
#include <forlink.h>

#define prg_files_dir   "sirprotdir"

extern "C" void sirprotmain_();
extern PangoFontDescription *fontdescP, *fontdescN, *fontdescU;

char *lck_file;
namespace main_app {
                                                                                                                      
Application TheApp = Application(" ", " ", " ", prg_files_dir);
                                                                                                                      
#ifdef __cplusplus
extern "C" {
#endif
int Main (int argc, char **argv)
{
     int i, result = TheApp.Initialize(argc, argv);

     if(!result)
        return -1;
     args->argc = argc;
     for(i=0; i<argc; i++)
         CopiaStringa(args->arg[i], MaxLenFilename, argv[i]);

     if(argc > 1)
     {
        std::string lock_file = argv[1];
        std::string lck_filestr;
        int ipos = (int)lock_file.rfind(".");
        if(ipos != -1)
        {
           lck_filestr = lock_file.substr (0, ipos) + ".lock";
           size_t sz = strlen(lck_filestr.c_str()) + 1;
           lck_file = g_new0(char, sz);
           CopiaStringa(lck_file, sz, lck_filestr.c_str());
        }
     }
           
     if(argc > 1)
        dir_set_current( g_path_get_dirname(argv[1]) );

    sirprotmain_();
    return 0;
}

#ifdef __cplusplus
}
#endif
}
int initGraphics()
{
   int result = main_app::TheApp.InitGraphics();
   fontdescN = pango_font_description_from_string (main_app::TheApp.FontN().c_str());
   fontdescP = pango_font_description_from_string (main_app::TheApp.FontP().c_str());
   fontdescU = pango_font_description_from_string (main_app::TheApp.FontU().c_str());
   return result;
}

GdkColor *get_colorgdk(int new_color)
{
   return main_app::TheApp.getgdkCol(new_color);
}

std::string main_dir()
{
    std::string dir = main_app::TheApp.MainDir();
    return dir;
}

